divert(-1)
define(`ZZ1ArrayZZ',`(:)')
define(`ZZ2ArrayZZ',`(:,:)')
define(`ZZ3ArrayZZ',`(:,:,:)')
define(`ZZ4ArrayZZ',`(:,:,:,:)')

define(`char_type',`integer*1')
define(`short_type',`integer*2')
define(`int_type',`integer')
define(`float_type',`real')
define(`double_type',`double precision')

define(`ICXJD_REGISTER_DATA',`
  subroutine icxjd_reg_$2D$1Array(epset, arrname, A, sts)
    type(ic_obj) :: epset
    character(len=*) :: arrname
    $1_type, dimension ZZ$2ArrayZZ :: A
    integer :: sts
    type(arraydesc) :: A_desc

    A_desc = createArrayDesc(A)
    call icxjd_reg_array_$1_helper(epset, arrname, A_desc, sts);
  end subroutine icxjd_reg_$2D$1Array'
)

define(`ICXJD_COMMIT_DATA',`
  subroutine icxjd_commit_arrays(epset, sts)
    type(ic_obj) :: epset
    integer :: sts 

    call icxjd_commit_arrays_helper(epset, sts)
  end subroutine icxjd_commit_arrays'
);

define(`ICXJD_IMPORT_DATA',`
  subroutine icxjd_import_array(epset, arrname, tag, sts)
    type(ic_obj) :: epset
    character(len=*) :: arrname
    integer :: tag
    integer :: sts

    call icxjd_imp_array_helper(epset, arrname, tag, sts)
  end subroutine icxjd_import_array'
)

define(`ICXJD_EXPORT_DATA',`
  subroutine icxjd_export_array(epset, arrname, tag, sts)
    type(ic_obj) :: epset
    character(len=*) :: arrname
    integer :: tag
    integer :: sts

    call icxjd_exp_array_helper(epset, arrname, tag, sts)
  end subroutine icxjd_export_array'
)

define(`ICXJD_RECV_LOCAL_DATA',`
  subroutine icxjd_r_localarr_$2D$1Array(epset, arrname, A, nelems, sts)
    type(ic_obj) :: epset
    $1_type, dimension ZZ$2ArrayZZ :: A
    character(len=*) :: arrname
    integer :: nelems
    integer :: sts

    type(arraydesc) :: A_desc 
    A_desc = createArrayDesc(A)
    call icxjd_r_localarr_$1_helper(epset, arrname, A_desc, nelems, sts)
    call destroy$1arraydesc(A_desc)
  end subroutine icxjd_r_localarr_$2D$1Array'
)

define(`ICXJD_BCAST_LOCAL_DATA',`
  subroutine icxjd_bc_localarr_$2D$1Array(epset, arrname, A, nelems, sts)
    type(ic_obj) :: epset
    $1_type, dimension ZZ$2ArrayZZ :: A
    character(len=*) :: arrname
    integer :: nelems
    integer :: sts

    type(arraydesc) :: A_desc 
    A_desc = createArrayDesc(A)
    call icxjd_bc_localarr_$1_helper(epset, arrname, A_desc, nelems, sts)
    call destroy$1arraydesc(A_desc)
  end subroutine icxjd_bc_localarr_$2D$1Array'
)




define(`IC_IMPORT_DATA',`
  subroutine ic_import_$2D$1Array(ico, A, tag, sts)
    type(ic_obj) :: ico 
    $1_type, dimension ZZ$2ArrayZZ :: A
    integer :: tag
    integer :: sts
    type(arraydesc) :: A_desc 
!    print *,">>>>>>>>>>>>>>>>>>>>>>>>>> before get$1Array"
!    write(6,fmt="(z7)") A_desc.this
    A_desc = createArrayDesc(A)
!    print *,">>>>>>>>>>>>>>>>>>>>>>>>>> after get$1Array"
!    write(6,fmt="(z7)") A_desc.this
!    print *,"in ic_import_array"
    call ic_import_array_$1_helper(ico,A_desc,tag,sts)
    call destroy$1arraydesc(A_desc)
  end subroutine ic_import_$2D$1Array')


define(`IC_RECV_LOCAL_DATA',`
  subroutine ic_recv_local_$2D$1Array(ico, A, nelems, tag, sts)
    type(ic_obj) :: ico 
    $1_type, dimension ZZ$2ArrayZZ :: A
    integer :: nelems
    integer :: tag
    integer :: sts

    type(arraydesc) :: A_desc 
    A_desc = createArrayDesc(A)
    call ic_recv_localarr_$1_helper(ico,A_desc,nelems,tag,sts)
    call destroy$1arraydesc(A_desc)
  end subroutine ic_recv_local_$2D$1Array')


define(`IC_EXPORT_DATA',`
  subroutine ic_export_$2D$1Array(ico, A, tag, sts)
    type(ic_obj) :: ico 
    $1_type, dimension ZZ$2ArrayZZ :: A
    integer :: tag
    integer :: sts
    type(arraydesc) :: A_desc 
    A_desc = createArrayDesc(A)
!    print *,"in ic_export_array"
    call ic_export_array_$1_helper(ico, A_desc, tag, sts)
    call destroy$1arraydesc(A_desc)
  end subroutine ic_export_$2D$1Array')

define(`IC_BCAST_LOCAL_DATA',`
  subroutine ic_bcast_local_$2D$1Array(ico, A, nelems, tag, sts)
    type(ic_obj) :: ico 
    $1_type, dimension ZZ$2ArrayZZ :: A
    integer :: nelems
    integer :: tag
    integer :: sts

    type(arraydesc) :: A_desc 
    A_desc = createArrayDesc(A)
    call ic_bcast_localarr_$1_helper(ico, A_desc, nelems, tag, sts)
    call destroy$1arraydesc(A_desc)
  end subroutine ic_bcast_local_$2D$1Array')

define(`IC_DUMP_ARRAY_INFO',`
  subroutine ic_dump_$2D$1Array_info(A)
    type(arraydesc) :: A_desc
    $1_type, dimension ZZ$2ArrayZZ :: A
    A_desc = createArrayDesc(A)
    call ic_dump_$1_arrayinternals(A_desc);
    call destroy$1arraydesc(A_desc)
  end subroutine ic_dump_$2D$1Array_info')

define(`IC_SEND',`
  subroutine ic_send_$2D$1(otherp,sched,data2send,tag,sts)
    integer otherp
    integer sched
    $1_type, dimension ZZ$2ArrayZZ :: data2send
    integer tag
    integer sts
    type(arraydesc) :: data2send_desc
    data2send_desc = createArrayDesc(data2send)
    call ic_send_$1_helper(otherp,sched,data2send_desc,tag,sts);
    call destroy$1arraydesc(data2send_desc)
  end subroutine ic_send_$2D$1')

define(`IC_RECV',`
  subroutine ic_recv_$2D$1(otherp,sched,data2recv,tag,sts)
    integer otherp
    integer sched
    $1_type, dimension ZZ$2ArrayZZ :: data2recv
    integer tag
    integer sts
    type(arraydesc) :: data2recv_desc
    data2recv_desc = createArrayDesc(data2recv)
    call ic_recv_$1_helper(otherp,sched,data2recv_desc,tag,sts);
    call destroy$1arraydesc(data2recv_desc)
  end subroutine ic_recv_$2D$1')

define(`IC_BCAST_LOCAL',`
  subroutine ic_bcast_local_$2D$1(otherp,data2send,nelems,tag,sts)
    integer otherp
    $1_type, dimension ZZ$2ArrayZZ :: data2send
    integer nelems 
    integer tag
    integer sts
    type(arraydesc) :: data2send_desc
    data2send_desc = createArrayDesc(data2send)
    call ic_bcast_local_$1_helper(otherp,data2send_desc,nelems,tag,sts);
    call destroy$1arraydesc(data2send_desc)
  end subroutine ic_bcast_local_$2D$1')

define(`IC_RECV_LOCAL',`
  subroutine ic_recv_local_$2D$1(otherp,data2recv,nelems,tag,sts)
    integer otherp
    $1_type, dimension ZZ$2ArrayZZ :: data2recv
    integer nelems 
    integer tag
    integer sts
    type(arraydesc) :: data2recv_desc
    data2recv_desc = createArrayDesc(data2recv)
    call ic_recv_local_$1_helper(otherp,data2recv_desc,nelems,tag,sts);
    call destroy$1arraydesc(data2recv_desc)
  end subroutine ic_recv_local_$2D$1')

divert
!------- module definition
module intercomm_interface

  use array_descriptor
  use array_printing

  implicit none

  include 'intercomm_interface.h'

  interface ic_commit_arrays
     module procedure &
         icxjd_commit_arrays
  end interface

  interface ic_register_array
     module procedure &
          icxjd_reg_1DintArray, &
          icxjd_reg_1DfloatArray, &
          icxjd_reg_1DdoubleArray, &
          icxjd_reg_2DintArray, &
          icxjd_reg_2DfloatArray, &
          icxjd_reg_2DdoubleArray, &
          icxjd_reg_3DintArray, &
          icxjd_reg_3DfloatArray, &
          icxjd_reg_3DdoubleArray, &
          icxjd_reg_4DintArray, &
          icxjd_reg_4DfloatArray, &
          icxjd_reg_4DdoubleArray
  end interface

  interface ic_export_array
     module procedure &
          ic_export_1DintArray, &
          ic_export_1DfloatArray, &
          ic_export_1DdoubleArray, &
          ic_export_2DintArray, &
          ic_export_2DfloatArray, &
          ic_export_2DdoubleArray, &
          ic_export_3DintArray, &
          ic_export_3DfloatArray, &
          ic_export_3DdoubleArray, &
          ic_export_4DintArray, &
          ic_export_4DfloatArray, &
          ic_export_4DdoubleArray, &
          icxjd_export_array
  end interface

  interface ic_import_array
     module procedure &
          ic_import_1DintArray, &
          ic_import_1DfloatArray, &
          ic_import_1DdoubleArray, &
          ic_import_2DintArray, &
          ic_import_2DfloatArray, &
          ic_import_2DdoubleArray, &
          ic_import_3DintArray, &
          ic_import_3DfloatArray, &
          ic_import_3DdoubleArray, &
          ic_import_4DintArray, &
          ic_import_4DfloatArray, &
          ic_import_4DdoubleArray, &
          icxjd_import_array
  end interface

  interface ic_bcast_local_array
     module procedure &
          ic_bcast_local_1DintArray, &
          ic_bcast_local_1DfloatArray, &
          ic_bcast_local_1DdoubleArray, &
          ic_bcast_local_2DintArray, &
          ic_bcast_local_2DfloatArray, &
          ic_bcast_local_2DdoubleArray, &
          ic_bcast_local_3DintArray, &
          ic_bcast_local_3DfloatArray, &
          ic_bcast_local_3DdoubleArray, &
          ic_bcast_local_4DintArray, &
          ic_bcast_local_4DfloatArray, &
          ic_bcast_local_4DdoubleArray, &
          icxjd_bc_localarr_1DintArray, &
          icxjd_bc_localarr_1DfloatArray, &
          icxjd_bc_localarr_1DdoubleArray, &
          icxjd_bc_localarr_2DintArray, &
          icxjd_bc_localarr_2DfloatArray, &
          icxjd_bc_localarr_2DdoubleArray, &
          icxjd_bc_localarr_3DintArray, &
          icxjd_bc_localarr_3DfloatArray, &
          icxjd_bc_localarr_3DdoubleArray, &
          icxjd_bc_localarr_4DintArray, &
          icxjd_bc_localarr_4DfloatArray, &
          icxjd_bc_localarr_4DdoubleArray
  end interface

  interface ic_recv_local_array
     module procedure &
          ic_recv_local_1DintArray, &
          ic_recv_local_1DfloatArray, &
          ic_recv_local_1DdoubleArray, &
          ic_recv_local_2DintArray, &
          ic_recv_local_2DfloatArray, &
          ic_recv_local_2DdoubleArray, &
          ic_recv_local_3DintArray, &
          ic_recv_local_3DfloatArray, &
          ic_recv_local_3DdoubleArray, &
          ic_recv_local_4DintArray, &
          ic_recv_local_4DfloatArray, &
          ic_recv_local_4DdoubleArray, &
          icxjd_r_localarr_1DintArray, &
          icxjd_r_localarr_1DfloatArray, &
          icxjd_r_localarr_1DdoubleArray, &
          icxjd_r_localarr_2DintArray, &
          icxjd_r_localarr_2DfloatArray, &
          icxjd_r_localarr_2DdoubleArray, &
          icxjd_r_localarr_3DintArray, &
          icxjd_r_localarr_3DfloatArray, &
          icxjd_r_localarr_3DdoubleArray, &
          icxjd_r_localarr_4DintArray, &
          icxjd_r_localarr_4DfloatArray, &
          icxjd_r_localarr_4DdoubleArray
  end interface

  interface ic_dump_array_info
     module procedure &
          ic_dump_1DintArray_info, &
          ic_dump_1DfloatArray_info, &
          ic_dump_1DdoubleArray_info, &
          ic_dump_2DintArray_info, &
          ic_dump_2DfloatArray_info, &
          ic_dump_2DdoubleArray_info, &
          ic_dump_3DintArray_info, &
          ic_dump_3DfloatArray_info, &
          ic_dump_3DdoubleArray_info, &
          ic_dump_4DintArray_info, &
          ic_dump_4DfloatArray_info, &
          ic_dump_4DdoubleArray_info
  end interface

!---- F90 LOLEVEL API
  interface ic_send
     module procedure &
          ic_send_1Dchar, &
          ic_send_2Dchar, &
          ic_send_3Dchar, &
          ic_send_4Dchar, &
          ic_send_1Dshort, &
          ic_send_2Dshort, &
          ic_send_3Dshort, &
          ic_send_4Dshort, &
          ic_send_1Dint, &
          ic_send_2Dint, &
          ic_send_3Dint, &
          ic_send_4Dint, &
          ic_send_1Dfloat, &
          ic_send_2Dfloat, &
          ic_send_3Dfloat, &
          ic_send_4Dfloat, &
          ic_send_1Ddouble, &
          ic_send_2Ddouble, &
          ic_send_3Ddouble, &
          ic_send_4Ddouble
  end interface

  interface ic_recv
     module procedure &
          ic_recv_1Dchar, &
          ic_recv_2Dchar, &
          ic_recv_3Dchar, &
          ic_recv_4Dchar, &
          ic_recv_1Dshort, &
          ic_recv_2Dshort, &
          ic_recv_3Dshort, &
          ic_recv_4Dshort, &
          ic_recv_1Dint, &
          ic_recv_2Dint, &
          ic_recv_3Dint, &
          ic_recv_4Dint, &
          ic_recv_1Dfloat, &
          ic_recv_2Dfloat, &
          ic_recv_3Dfloat, &
          ic_recv_4Dfloat, &
          ic_recv_1Ddouble, &
          ic_recv_2Ddouble, &
          ic_recv_3Ddouble, &
          ic_recv_4Ddouble
  end interface

  interface ic_bcast_local
     module procedure &
          ic_bcast_local_1Dchar, &
          ic_bcast_local_2Dchar, &
          ic_bcast_local_3Dchar, &
          ic_bcast_local_4Dchar, &
          ic_bcast_local_1Dshort, &
          ic_bcast_local_2Dshort, &
          ic_bcast_local_3Dshort, &
          ic_bcast_local_4Dshort, &
          ic_bcast_local_1Dint, &
          ic_bcast_local_2Dint, &
          ic_bcast_local_3Dint, &
          ic_bcast_local_4Dint, &
          ic_bcast_local_1Dfloat, &
          ic_bcast_local_2Dfloat, &
          ic_bcast_local_3Dfloat, &
          ic_bcast_local_4Dfloat, &
          ic_bcast_local_1Ddouble, &
          ic_bcast_local_2Ddouble, &
          ic_bcast_local_3Ddouble, &
          ic_bcast_local_4Ddouble
  end interface

  interface ic_recv_local
     module procedure &
          ic_recv_local_1Dchar, &
          ic_recv_local_2Dchar, &
          ic_recv_local_3Dchar, &
          ic_recv_local_4Dchar, &
          ic_recv_local_1Dshort, &
          ic_recv_local_2Dshort, &
          ic_recv_local_3Dshort, &
          ic_recv_local_4Dshort, &
          ic_recv_local_1Dint, &
          ic_recv_local_2Dint, &
          ic_recv_local_3Dint, &
          ic_recv_local_4Dint, &
          ic_recv_local_1Dfloat, &
          ic_recv_local_2Dfloat, &
          ic_recv_local_3Dfloat, &
          ic_recv_local_4Dfloat, &
          ic_recv_local_1Ddouble, &
          ic_recv_local_2Ddouble, &
          ic_recv_local_3Ddouble, &
          ic_recv_local_4Ddouble
  end interface

  type ic_obj
!  the InterComm object is a pointer. Pointers require 4 bytes
     character(4) :: this
  end type ic_obj
  
contains

!---- XJDHILEVEL Common
  ICXJD_COMMIT_DATA()
  ICXJD_EXPORT_DATA()
  ICXJD_IMPORT_DATA()

!---- F90 HILEVEL API
!---- 1D
  IC_IMPORT_DATA(int,1)
  IC_EXPORT_DATA(int,1)
  IC_BCAST_LOCAL_DATA(int,1)
  IC_RECV_LOCAL_DATA(int,1)
  IC_DUMP_ARRAY_INFO(int,1)
  ICXJD_REGISTER_DATA(int,1)
  ICXJD_BCAST_LOCAL_DATA(int,1)
  ICXJD_RECV_LOCAL_DATA(int,1)

  IC_IMPORT_DATA(float,1)
  IC_EXPORT_DATA(float,1)
  IC_BCAST_LOCAL_DATA(float,1)
  IC_RECV_LOCAL_DATA(float,1)
  IC_DUMP_ARRAY_INFO(float,1)
  ICXJD_REGISTER_DATA(float,1)
  ICXJD_BCAST_LOCAL_DATA(float,1)
  ICXJD_RECV_LOCAL_DATA(float,1)

  IC_IMPORT_DATA(double,1)
  IC_EXPORT_DATA(double,1)
  IC_BCAST_LOCAL_DATA(double,1)
  IC_RECV_LOCAL_DATA(double,1)
  IC_DUMP_ARRAY_INFO(double,1)
  ICXJD_REGISTER_DATA(double,1)
  ICXJD_BCAST_LOCAL_DATA(double,1)
  ICXJD_RECV_LOCAL_DATA(double,1)
 
!---- 2D
  IC_IMPORT_DATA(int,2)
  IC_EXPORT_DATA(int,2)
  IC_BCAST_LOCAL_DATA(int,2)
  IC_RECV_LOCAL_DATA(int,2)
  IC_DUMP_ARRAY_INFO(int,2)
  ICXJD_REGISTER_DATA(int,2)
  ICXJD_BCAST_LOCAL_DATA(int,2)
  ICXJD_RECV_LOCAL_DATA(int,2)

  IC_IMPORT_DATA(float,2)
  IC_EXPORT_DATA(float,2)
  IC_BCAST_LOCAL_DATA(float,2)
  IC_RECV_LOCAL_DATA(float,2)
  IC_DUMP_ARRAY_INFO(float,2)
  ICXJD_REGISTER_DATA(float,2)
  ICXJD_BCAST_LOCAL_DATA(float,2)
  ICXJD_RECV_LOCAL_DATA(float,2)

  IC_IMPORT_DATA(double,2)
  IC_EXPORT_DATA(double,2)
  IC_BCAST_LOCAL_DATA(double,2)
  IC_RECV_LOCAL_DATA(double,2)
  IC_DUMP_ARRAY_INFO(double,2)
  ICXJD_REGISTER_DATA(double,2)
  ICXJD_BCAST_LOCAL_DATA(double,2)
  ICXJD_RECV_LOCAL_DATA(double,2)
 
!---- 3D
  IC_IMPORT_DATA(int,3)
  IC_EXPORT_DATA(int,3)
  IC_BCAST_LOCAL_DATA(int,3)
  IC_RECV_LOCAL_DATA(int,3)
  IC_DUMP_ARRAY_INFO(int,3)
  ICXJD_REGISTER_DATA(int,3)
  ICXJD_BCAST_LOCAL_DATA(int,3)
  ICXJD_RECV_LOCAL_DATA(int,3)

  IC_IMPORT_DATA(float,3)
  IC_EXPORT_DATA(float,3)
  IC_BCAST_LOCAL_DATA(float,3)
  IC_RECV_LOCAL_DATA(float,3)
  IC_DUMP_ARRAY_INFO(float,3)
  ICXJD_REGISTER_DATA(float,3)
  ICXJD_BCAST_LOCAL_DATA(float,3)
  ICXJD_RECV_LOCAL_DATA(float,3)

  IC_IMPORT_DATA(double,3)
  IC_EXPORT_DATA(double,3)
  IC_BCAST_LOCAL_DATA(double,3)
  IC_RECV_LOCAL_DATA(double,3)
  IC_DUMP_ARRAY_INFO(double,3)
  ICXJD_REGISTER_DATA(double,3)
  ICXJD_BCAST_LOCAL_DATA(double,3)
  ICXJD_RECV_LOCAL_DATA(double,3)

!---- 4D
  IC_IMPORT_DATA(int,4)
  IC_EXPORT_DATA(int,4)
  IC_BCAST_LOCAL_DATA(int,4)
  IC_RECV_LOCAL_DATA(int,4)
  IC_DUMP_ARRAY_INFO(int,4)
  ICXJD_REGISTER_DATA(int,4)
  ICXJD_BCAST_LOCAL_DATA(int,4)
  ICXJD_RECV_LOCAL_DATA(int,4)

  IC_IMPORT_DATA(float,4)
  IC_EXPORT_DATA(float,4)
  IC_BCAST_LOCAL_DATA(float,4)
  IC_RECV_LOCAL_DATA(float,4)
  IC_DUMP_ARRAY_INFO(float,4)
  ICXJD_REGISTER_DATA(float,4)
  ICXJD_BCAST_LOCAL_DATA(float,4)
  ICXJD_RECV_LOCAL_DATA(float,4)

  IC_IMPORT_DATA(double,4)
  IC_EXPORT_DATA(double,4)
  IC_BCAST_LOCAL_DATA(double,4)
  IC_RECV_LOCAL_DATA(double,4)
  IC_DUMP_ARRAY_INFO(double,4)
  ICXJD_REGISTER_DATA(double,4)
  ICXJD_BCAST_LOCAL_DATA(double,4)
  ICXJD_RECV_LOCAL_DATA(double,4)


!---- F90 LOLEVEL API 
!---- char
  IC_SEND(char,1)
  IC_RECV(char,1)
  IC_BCAST_LOCAL(char,1)
  IC_RECV_LOCAL(char,1)
  IC_SEND(char,2)
  IC_RECV(char,2)
  IC_BCAST_LOCAL(char,2)
  IC_RECV_LOCAL(char,2)
  IC_SEND(char,3)
  IC_RECV(char,3)
  IC_BCAST_LOCAL(char,3)
  IC_RECV_LOCAL(char,3)
  IC_SEND(char,4)
  IC_RECV(char,4)
  IC_BCAST_LOCAL(char,4)
  IC_RECV_LOCAL(char,4)

!---- short
  IC_SEND(short,1)
  IC_RECV(short,1)
  IC_BCAST_LOCAL(short,1)
  IC_RECV_LOCAL(short,1)
  IC_SEND(short,2)
  IC_RECV(short,2)
  IC_BCAST_LOCAL(short,2)
  IC_RECV_LOCAL(short,2)
  IC_SEND(short,3)
  IC_RECV(short,3)
  IC_BCAST_LOCAL(short,3)
  IC_RECV_LOCAL(short,3)
  IC_SEND(short,4)
  IC_RECV(short,4)
  IC_BCAST_LOCAL(short,4)
  IC_RECV_LOCAL(short,4)

!---- int
  IC_SEND(int,1)
  IC_RECV(int,1)
  IC_BCAST_LOCAL(int,1)
  IC_RECV_LOCAL(int,1)
  IC_SEND(int,2)
  IC_RECV(int,2)
  IC_BCAST_LOCAL(int,2)
  IC_RECV_LOCAL(int,2)
  IC_SEND(int,3)
  IC_RECV(int,3)
  IC_BCAST_LOCAL(int,3)
  IC_RECV_LOCAL(int,3)
  IC_SEND(int,4)
  IC_RECV(int,4)
  IC_BCAST_LOCAL(int,4)
  IC_RECV_LOCAL(int,4)

!---- float
  IC_SEND(float,1)
  IC_RECV(float,1)
  IC_BCAST_LOCAL(float,1)
  IC_RECV_LOCAL(float,1)
  IC_SEND(float,2)
  IC_RECV(float,2)
  IC_BCAST_LOCAL(float,2)
  IC_RECV_LOCAL(float,2)
  IC_SEND(float,3)
  IC_RECV(float,3)
  IC_BCAST_LOCAL(float,3)
  IC_RECV_LOCAL(float,3)
  IC_SEND(float,4)
  IC_RECV(float,4)
  IC_BCAST_LOCAL(float,4)
  IC_RECV_LOCAL(float,4)

!---- double
  IC_SEND(double,1)
  IC_RECV(double,1)
  IC_BCAST_LOCAL(double,1)
  IC_RECV_LOCAL(double,1)
  IC_SEND(double,2)
  IC_RECV(double,2)
  IC_BCAST_LOCAL(double,2)
  IC_RECV_LOCAL(double,2)
  IC_SEND(double,3)
  IC_RECV(double,3)
  IC_BCAST_LOCAL(double,3)
  IC_RECV_LOCAL(double,3)
  IC_SEND(double,4)
  IC_RECV(double,4)
  IC_BCAST_LOCAL(double,4)
  IC_RECV_LOCAL(double,4)


! Maybe, following code is for F90 low-level API

  subroutine ic_create_bdecomp_desc(rank,blocks,tasks,nblocks,desc,arrorder)
    integer rank
    integer, dimension (:,:,:) :: blocks
    integer, dimension (:) :: tasks
    integer nblocks
    integer :: desc
    integer :: arrorder
    type(arraydesc) :: blocks_desc
    type(arraydesc) :: tasks_desc
    blocks_desc = createArrayDesc(blocks)
    tasks_desc = createArrayDesc(tasks)
    call ic_create_bdecomp_desc_helper(rank,blocks_desc,tasks_desc,nblocks,desc,arrorder);
    call destroyintarraydesc(tasks_desc)
    call destroyintarraydesc(blocks_desc)
  end subroutine ic_create_bdecomp_desc

  subroutine ic_create_ttable_desc(globals,locals,tasks,count,desc)
    integer, dimension (:) :: globals
    integer, dimension (:) :: locals
    integer, dimension (:) :: tasks
    integer :: count
    integer :: desc
    type(arraydesc) :: globals_desc
    type(arraydesc) :: locals_desc
    type(arraydesc) :: tasks_desc
    globals_desc = createArrayDesc(globals)
    locals_desc = createArrayDesc(locals)
    tasks_desc = createArrayDesc(tasks)
    call ic_create_ttable_desc_helper(globals_desc,locals_desc,tasks_desc,count,desc);
    call destroyintarraydesc(globals_desc)
    call destroyintarraydesc(locals_desc)
    call destroyintarraydesc(tasks_desc)
  end subroutine ic_create_ttable_desc

  subroutine ic_create_block_region(rank,lower,upper,stride,region)
    integer rank
    integer, dimension (:) :: lower
    integer, dimension (:) :: upper
    integer, dimension (:) :: stride
    integer :: region
    type(arraydesc) :: lower_desc
    type(arraydesc) :: upper_desc
    type(arraydesc) :: stride_desc
    lower_desc = createArrayDesc(lower)
    upper_desc = createArrayDesc(upper)
    stride_desc = createArrayDesc(stride)
    call ic_create_block_region_helper(rank,lower_desc,upper_desc,stride_desc,region);
    call destroyintarraydesc(lower_desc)
    call destroyintarraydesc(upper_desc)
    call destroyintarraydesc(stride_desc)
  end subroutine ic_create_block_region

  subroutine ic_create_enum_region(indices,size,region)
    integer, dimension (:) :: indices
    integer size
    integer :: region
    type(arraydesc) :: indices_desc
    indices_desc = createArrayDesc(indices)
    call ic_create_enum_region_helper(indices_desc,size,region);
    call destroyintarraydesc(indices_desc)
  end subroutine ic_create_enum_region

  subroutine ic_compute_schedule(thisp,otherp,desc,region_set,set_size,sched)
    integer thisp
    integer otherp
    integer desc
    integer, dimension (:) :: region_set
    integer set_size
    integer sched
    type(arraydesc) :: region_set_desc
    region_set_desc = createArrayDesc(region_set)
    call ic_compute_schedule_helper(thisp,otherp,desc,region_set_desc,set_size,sched);
    call destroyintarraydesc(region_set_desc)
  end subroutine ic_compute_schedule

end module intercomm_interface
