/**
 * $Author: normanlo $
 * $Date: 2006/05/02 23:04:48 $
 * $Revision: 1.1.2.58 $
 * $Source: /fs/schisto7/parti/repository/InterComm/src/Attic/xjd_handle.c,v $
 * 
 * Written by Il-Chul Yoon <iyoon@cs.umd.edu>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "intercomm.h"
#include "pgme.h"
#include "ezxml/ezxml.h"
#include "xjd_handle.h"  

int XJD_Validate(IC_XJD* xjd){
   
   /** 
    * TODO: should implement later...
    *   inspect for the component and connection information 
    *   based on the version information
    */

   return 1; 
}

IC_XJD* IC_Initialize(char* pName, int rank, char* xjdname, int* icsts){
    IC_XJD* xjd = NULL;

    xjd = (IC_XJD*) malloc(sizeof(IC_XJD));
    xjd->version = NULL;
    xjd->cHeader = NULL;
    xjd->cTail   = NULL;
    xjd->rHeader = NULL;
    xjd->rTail   = NULL;
    xjd->meou    = NULL;

    /* assign root of global XJD structure */
    xjd->xmlRoot = read_xjd(xjdname);

    /* get version info */
    xjd->version = strdup(get_version(xjd->xmlRoot));
    fprintf(stderr, "version %s\n", xjd->version);

    if(XJD_Validate(xjd) < 0){
        return NULL;
    }
    
    if(!strcmp(xjd->version, "1.5")){
        IC_Initialize_1_5(xjd, pName, rank, icsts);
    }
    else if(!strcmp(xjd->version, "2.0")){
        IC_Initialize_2_0();
    }
  
    *icsts = ((xjd == NULL) ? -1 : 0);
 
    return xjd;
}

void IC_Initialize_1_5(IC_XJD* xjd, char* pName, int rank, int* icsts){
    IC_XJDComponent* tmp;
    IC_XJDRegion* rgn;

    /* register myself */
    *icsts = register_program(pName, xjd);
    if(*icsts < 0){
        return;
    }

    /* inspect connections to look for the components related to me */
    inspect_connections(pName, xjd);

    /* initializate components - set IC_Program ptr in IC_XJDComponent */
    tmp = (IC_XJDComponent*) xjd->cHeader;
    rgn = (IC_XJDRegion*) xjd->rHeader;

    tmp->comp = IC_Init(tmp->name, tmp->ntask, rank);
    tmp = (IC_XJDComponent*) tmp->next;
        
    fprintf(stderr, "======= COMPONENT LIST (IC_Wait...)=======\n");
    while(tmp){
        print_comp(tmp);

        tmp->comp = IC_Wait(tmp->name, tmp->ntask);
        tmp = (IC_XJDComponent*) tmp->next;
    }

    /* initialize connections (regions) - connect IC_Programs in region */
    while(rgn){
        rgn->me = search_program(rgn->myname, xjd);  
        rgn->partner = search_program(rgn->partnername, xjd);
        
        /* to prevent partner terminates too early... */
        IC_Sync(rgn->me, rgn->partner);
        
        rgn = (IC_XJDRegion*) rgn->next;
    }
}

void IC_Initialize_2_0(){
    
}

/*
IC_RegionHandle* IC_InitHandle(IC_XJD* xjd, int* icsts){
    
    *icsts = 0;
    
    if(!strcmp(xjd->version, "1.5")){
        return (IC_RegionHandle*)IC_InitHandle_1_5();
    }
    else if(!strcmp(xjd->version, "2.0")){
        return (IC_RegionHandle*)IC_InitHandle_2_0();
    }
  
    *icsts = -1;
    return NULL;
}


IC_RegionHandle* IC_InitHandle_1_5(){
    IC_RegionHandle* handle = (IC_RegionHandle*) malloc(sizeof(IC_RegionHandle));
    handle->rgn = NULL;
    
    return handle;
}


IC_RegionHandle* IC_InitHandle_2_0(){
    IC_RegionHandle* handle = (IC_RegionHandle*) malloc(sizeof(IC_RegionHandle));

    //code here for SML 
        
    return handle;
}
*/

void IC_Register_region(IC_XJD* xjd, IC_Region** rgnset, int set_size, char* set_name, IC_Desc* desc, void* local_data, int* icsts){
    if(!strcmp(xjd->version, "1.5")){
        IC_Register_region_1_5(xjd, rgnset, set_size, set_name, \
                               desc, local_data, icsts);
    }
    else if(!strcmp(xjd->version, "2.0")){
        IC_Register_region_2_0(xjd, rgnset, set_size, set_name, \
                               desc, local_data, icsts);
    }
}


void IC_Register_region_1_5(IC_XJD* xjd, IC_Region** rgnset, int set_size, char* set_name, IC_Desc* desc, void* local_data, int* icsts){
    IC_XJDRegion* rgn;
    IC_Region** regioncopy;
    int i;
   
    rgn = search_region(set_name, xjd);

    if(rgn == NULL){
    	fprintf(stderr, "%s is not used\n", set_name);
        *icsts = XJDREGION_REGISTER_ERR;
        return;
    }

    regioncopy = (IC_Region**)calloc(set_size, sizeof(IC_Region*));
    for (i = 0; i < set_size; ++i) {
        regioncopy[i] = rgnset[i];
    }
  
    rgn->local_data = local_data;
    rgn->rgn_desc = desc;
    rgn->region = regioncopy;
    rgn->rgn_size = set_size;

    *icsts = XJDREGION_REGISTER_OK;
}


void IC_Register_region_2_0(IC_XJD* xjd, IC_Region** rgnset, int set_size, char* set_name, IC_Desc* desc, void* local_data, int* icsts){
/*
    SMLregister("Ap2Sr1",  <=> set_name
                desc, <=> desc
                Sr1, <=> rgnset
                1,  <=> set_size
                local_data, <=> local_data
                sizeof(local_data), <=> Not exist.. We should resolve this.
                IC_float, <=> can find in XJD using set_name (in string)
                &th1 <=> handle
               )
*/                
}


void IC_Commit_region(IC_XJD* xjd, int* icsts){
    if(!strcmp(xjd->version, "1.5")){
        IC_Commit_region_1_5(xjd, icsts);
    }
    else if(!strcmp(xjd->version, "2.0")){
        IC_Commit_region_2_0();
    }
}


void IC_Commit_region_1_5(IC_XJD* xjd, int* icsts){
    IC_XJDRegion* rgn = (IC_XJDRegion*) xjd->rHeader;
    
    while(rgn){
        if(!strcmp(rgn->commtype, "MxN")){
            rgn->sched = IC_Compute_schedule(rgn->me, 
                                             rgn->partner, 
                                             rgn->rgn_desc,
                                             rgn->region,
                                             rgn->rgn_size);
            
            if(rgn->sched == NULL){
                fprintf(stderr, "sched generation failed\n");
                *icsts = IC_COMPUTE_SCHED_FAILED;
                return;
            }
        }
        rgn = (IC_XJDRegion*) rgn->next;
    }
    
    *icsts = XJDREGION_COMMIT_OK;
}


void IC_Commit_region_2_0(){

}

int IC_Export(IC_XJD* xjd, char* rgnset_name){
    if(!strcmp(xjd->version, "1.5")){
        return IC_Export_1_5(xjd, rgnset_name);
    }
    else if(!strcmp(xjd->version, "2.0")){
        return IC_Export_2_0(rgnset_name);
    }
}  


int IC_Export_1_5(IC_XJD* xjd, char* rgnset_name){
    IC_XJDRegion* rgn = search_region(rgnset_name, xjd);
    int status = 0;
    
    if(!strcmp(rgn->commtype, "MxN")){
        /**
         * long type is defined in the intercomm.h. However, it is not defined 
         * in the move.m4 file. 
         */ 
        if( !strcmp(rgn->type, "char")){
            status = IC_Send_char(rgn->partner, rgn->sched, (char*)rgn->local_data, rgn->tag);
        }
        else if( !strcmp(rgn->type, "short")){
            status = IC_Send_short(rgn->partner, rgn->sched, (short*)rgn->local_data, rgn->tag);
        }
        else if( !strcmp(rgn->type, "int")){
            status = IC_Send_int(rgn->partner, rgn->sched, (int*)rgn->local_data, rgn->tag);
        }
        else if( !strcmp(rgn->type, "float")){
            status = IC_Send_float(rgn->partner, rgn->sched, (float*) rgn->local_data, rgn->tag);
        }
        else if( !strcmp(rgn->type, "double")){
            status = IC_Send_double(rgn->partner, rgn->sched, (double*) rgn->local_data, rgn->tag);
        }
    }
    else{
        status = -1;            
    }
    
    if(status == -1){
        fprintf(stderr, "%s send with %d failed\n", rgn->my_region_name, rgn->tag);
        return IC_EXPORT_FAILED;
    }
    else{
        fprintf(stderr, "%s send with %d succeed\n", rgn->my_region_name, rgn->tag);
    }
        
    return IC_OK;
}


int IC_Export_2_0(char* rgnset_name){
    return IC_OK; 
}


int IC_Import(IC_XJD* xjd, char* rgnset_name){
    if(!strcmp(xjd->version, "1.5")){
        IC_Import_1_5(xjd, rgnset_name);
    }
    else if(!strcmp(xjd->version, "2.0")){
        IC_Import_2_0(rgnset_name);
    }
}  

int IC_Import_1_5(IC_XJD* xjd, char* rgnset_name){
    IC_XJDRegion* rgn = search_region(rgnset_name, xjd);
    int status = 0;
    
    if(!strcmp(rgn->commtype, "MxN")){
        /**
         * long type is defined in the intercomm.h. However, it is not defined 
         * in the move.m4 file. 
         */ 
        if( !strcmp(rgn->type, "char")){
            status = IC_Recv_char(rgn->partner, rgn->sched, (char*)rgn->local_data, rgn->tag);
        }
        else if( !strcmp(rgn->type, "short")){
            status = IC_Recv_short(rgn->partner, rgn->sched, (short*)rgn->local_data, rgn->tag);
        }
        else if( !strcmp(rgn->type, "int")){
            status = IC_Recv_int(rgn->partner, rgn->sched, (int*)rgn->local_data, rgn->tag);
        }
        else if( !strcmp(rgn->type, "float")){
            status = IC_Recv_float(rgn->partner, rgn->sched, (float*) rgn->local_data, rgn->tag);
        }
        else if( !strcmp(rgn->type, "double")){
            status = IC_Recv_double(rgn->partner, rgn->sched, (double*) rgn->local_data, rgn->tag);
        }
    }
    else{
        status = -1;            
    }

    if(status == -1){
        fprintf(stderr, "%s recv with %d failed \n", rgn->my_region_name, rgn->tag);
        return IC_IMPORT_FAILED;
    }
    else{
        fprintf(stderr, "%s recv with %d succeed\n", rgn->my_region_name, rgn->tag);
    }
        
    return IC_OK;
}


int IC_Import_2_0(char* rgnset_name){
    return IC_OK; 
}

/** 
 * <iyoon>
 * In fact, this functionality can be implemented with IC_Export 
 * by separating usual export and broadcast using 'commtype'. 
 * However, explicit representation by function name is better.
 *
 * The reason data and nelems are provided, is to give users 
 * flexibility to broadcast data to destination processes.
 * In case of 1xN region, the tag, data type and communication type 
 * are the only important information in region definition.
 * 1xN region is excluded in schedule generation 
 */
int IC_BCast_Local(IC_XJD* xjd, char* rgnset_name, void* data, int nelems){
    return IC_BCast_Local_1_5(xjd, rgnset_name, data, nelems);
}

int IC_BCast_Local_1_5(IC_XJD* xjd, char* rgnset_name, void* data, int nelems){
    IC_XJDRegion* rgn = search_region(rgnset_name, xjd);
    int stat = 0;
    
    if(!strcmp(rgn->commtype, "1xN")){
        if( !strcmp(rgn->type, "char")){
            stat = IC_BCast_Local_char(rgn->partner, (char*)data, nelems, rgn->tag); 
        }
        else if( !strcmp(rgn->type, "short")){
            stat = IC_BCast_Local_short(rgn->partner, (short*)data, nelems, rgn->tag); 
        }
        else if( !strcmp(rgn->type, "int")){
            stat = IC_BCast_Local_int(rgn->partner, (int*)data, nelems, rgn->tag); 
        }
        else if( !strcmp(rgn->type, "float")){
            stat = IC_BCast_Local_float(rgn->partner, (float*)data, nelems, rgn->tag); 
        }
        else if( !strcmp(rgn->type, "double")){
            stat = IC_BCast_Local_double(rgn->partner, (double*)data, nelems, rgn->tag); 
        }
    }
    else{
        stat = -1;            
    }
    
    if(stat == -1){
        fprintf(stderr, "%s broadcast with %d failed\n", rgn->my_region_name, rgn->tag);
        return IC_EXPORT_FAILED;
    }
    else{
        fprintf(stderr, "%s broadcast with %d succeed\n", rgn->my_region_name, rgn->tag);
    }
       
    return IC_OK; 
}


int IC_Recv_Local(IC_XJD* xjd, char* rgnset_name, void* data, int nelems){
    return IC_Recv_Local_1_5(xjd, rgnset_name, data, nelems);
}

int IC_Recv_Local_1_5(IC_XJD* xjd, char* rgnset_name, void* data, int nelems){
    IC_XJDRegion* rgn = search_region(rgnset_name, xjd);
    int stat = 0;
    
    if(!strcmp(rgn->commtype, "1xN")){
        if( !strcmp(rgn->type, "char")){
            stat = IC_Recv_Local_char(rgn->partner, (char*)data, nelems, rgn->tag); 
        }
        else if( !strcmp(rgn->type, "short")){
            stat = IC_Recv_Local_short(rgn->partner, (short*)data, nelems, rgn->tag); 
        }
        else if( !strcmp(rgn->type, "int")){
            stat = IC_Recv_Local_int(rgn->partner, (int*)data, nelems, rgn->tag); 
        }
        else if( !strcmp(rgn->type, "float")){
            stat = IC_Recv_Local_float(rgn->partner, (float*)data, nelems, rgn->tag); 
        }
        else if( !strcmp(rgn->type, "double")){
            stat = IC_Recv_Local_double(rgn->partner, (double*)data, nelems, rgn->tag); 
        }
    }
    else{
        stat = -1;            
    }
    
    if(stat == -1){
        fprintf(stderr, "%s recv (matched to broadcast) with %d failed\n", rgn->my_region_name, rgn->tag);
        return IC_EXPORT_FAILED;
    }
    else{
        fprintf(stderr, "%s recv (matched to broadcast) with %d succeed\n", rgn->my_region_name, rgn->tag);
    }
        
    return IC_OK;
}



/*
void IC_Free_RegionHandle(IC_XJD* xjd, IC_RegionHandle* handle, int* icsts){
    if(!strcmp(xjd->version, "1.5")){
        IC_Free_RegionHandle_1_5(handle, icsts);
    }
    else if(!strcmp(xjd->version, "2.0")){
        IC_Free_RegionHandle_2_0(handle, icsts);
    }
}


void IC_Free_RegionHandle_1_5(IC_RegionHandle* handle, int* icsts){
    *icsts = 0; 
    free(handle);  
}


void IC_Free_RegionHandle_2_0(IC_RegionHandle* handle, int* icsts){
    *icsts = 0;
}
*/    

void IC_Finalize(IC_XJD* xjd, int* icsts){
    if(!strcmp(xjd->version, "1.5")){
        IC_Finalize_1_5(xjd, icsts);
    }
    else if(!strcmp(xjd->version, "2.0")){
        IC_Finalize_2_0();
    }
}

    
void IC_Finalize_1_5(IC_XJD* xjd, int* icsts){
    /* remove all IC_XJDRegion*/
    if(xjd->rHeader != NULL){
        release_rgn((IC_XJDRegion*) xjd->rHeader);
    }

    /* remove all IC_XJDComponent*/
    if(xjd->cHeader != NULL){
        IC_XJDComponent* firstcomp = (IC_XJDComponent*) xjd->cHeader;
        
        release_comp( (IC_XJDComponent*) firstcomp->next, 0);
        release_comp( (IC_XJDComponent*) firstcomp, 1);
    }

    free_xjd(xjd->xmlRoot);
    
    xjd->cHeader = xjd->cTail = NULL;
    xjd->rHeader = xjd->rTail = NULL;
    free(xjd->version);
    free(xjd);
    
    *icsts = 0;
}    


void IC_Finalize_2_0(){

}    


void IC_Sync_by_rgn(char* rgn_name, IC_XJD* xjd, int* icsts){
    IC_XJDRegion* rgn = search_region(rgn_name, xjd);
    IC_Sync(rgn->me, rgn->partner);    
    
    *icsts = 0;
}





void release_rgn(IC_XJDRegion* ptr){
    if(ptr == NULL){
        return;
    }
    
    if(ptr->next != NULL){
        release_rgn((IC_XJDRegion*) ptr->next);
    }

    /* sync before termination*/
    IC_Sync(ptr->me, ptr->partner);

    /* release memory for IC_XJDRegion*/
    if(ptr->sched){
        IC_Free_sched(ptr->sched);
    }
    if(ptr->region){
        free(ptr->region);
    }
    free(ptr->myname);
    free(ptr->partnername);
    free(ptr->type);
    free(ptr->commtype);
    free(ptr->my_region_name);
    free(ptr->partner_region_name);
    free(ptr);
}


void release_comp(IC_XJDComponent* ptr, int first){
    if(ptr == NULL){
        return;
    }

    if(first){
        IC_Quit(ptr->comp);
        free(ptr->name);
        free(ptr);
        return;
    }
    
    if(ptr->next != NULL){
        release_comp((IC_XJDComponent*) ptr->next, 0);
    }

    /* release memory for IC_XJDComponent*/
    IC_Free_program(ptr->comp);
    free(ptr->name);
    free(ptr);
}

int inspect_connections(const char* myname, IC_XJD* xjd){
    ezxml_t curConn, exp, imp;
    char* cid;
    char* pname;
    char* pname2;
    
    curConn = get_first_conn(xjd->xmlRoot);
    
    while(curConn){
        exp = ezxml_child(curConn, EXPORTER);
        pname = search_pname_byID(exp->txt, xjd);
        
        if( !strcmp(myname, pname) ){
            fprintf(stderr, "\tappear as exp: %s\n", pname);
            
            imp = ezxml_child(curConn, IMPORTER);
            pname2 = search_pname_byID(imp->txt, xjd);
            
            if( search_program(pname2, xjd) == NULL){
                register_program(pname2, xjd);
            }
            
            register_region( \
                    pname, pname2,  \
                    ezxml_child(curConn, EXPPORT)->txt, \
                    ezxml_child(curConn, IMPPORT)->txt, \
                    ezxml_child(curConn, DATATYPE)->txt, \
                    ezxml_child(curConn, COMMTYPE)->txt, \
                    atoi(ezxml_child(curConn, TAG)->txt), \
                    xjd);
                    
        }
        
        imp = ezxml_child(curConn, IMPORTER);
        pname = search_pname_byID(imp->txt, xjd);
        
        if( !strcmp(myname, pname) ){
            fprintf(stderr, "\tappear as imp: %s\n", pname);                                    

            exp = ezxml_child(curConn, EXPORTER);
            pname2 = search_pname_byID(exp->txt, xjd);
            
            if( search_program(pname2, xjd) == NULL){
                register_program(pname2, xjd);
            }
            
            register_region( \
                    pname, pname2,  \
                    ezxml_child(curConn, IMPPORT)->txt, \
                    ezxml_child(curConn, EXPPORT)->txt, \
                    ezxml_child(curConn, DATATYPE)->txt, \
                    ezxml_child(curConn, COMMTYPE)->txt, \
                    atoi(ezxml_child(curConn, TAG)->txt), \
                    xjd);
                    
        }
        
        exp = imp = NULL;
        curConn = curConn->next;
    }
}


int register_program(const char* pName, IC_XJD* xjd){
    ezxml_t curComp;
    ezxml_t tmp, tmpstr, cid;
    IC_XJDComponent* aComp;
   
    curComp = get_first_comp(xjd->xmlRoot);
    
    while(curComp){
        cid = ezxml_child(curComp, COMPID);
        tmp = ezxml_child(curComp, COMPNAME);

        if(cid == NULL){
            fprintf(stderr, "Invalid CID (Review XJD file)...\n");
            break;
        }
        if(tmp == NULL){
            fprintf(stderr, "Failed to find the component name in XJD...\n");
            break;
        }
        
        if( !strcmp(pName, tmp->txt) ){
            aComp = (IC_XJDComponent*) malloc(sizeof(IC_XJDComponent));
           
            aComp->id = (char*)strdup(cid->txt);
            aComp->name = (char*)strdup(pName);
            
            tmpstr = ezxml_child(curComp, N_NODE); 
            if(tmpstr){
                aComp->ntask = atoi(tmpstr->txt);
            }
            
            aComp->comp = (IC_Program*) NULL;
            aComp->next = (IC_XJDComponent*) NULL;
            
            add_comp((IC_XJDComponent*)aComp, xjd);
            
            return XJDCOMP_REGISTER_OK;
        }

        curComp = curComp->next;
    }
    
    return XJDCOMP_REGISTER_ERR;
}

int register_region(
    char* myname, char* partnername,
    char* my_region_name, char* partner_region_name, char* type, char* commtype,
    int tag, IC_XJD* xjd
){
    IC_XJDRegion* aRegion;
            
    fprintf(stderr, "Register Region %s\n", my_region_name);
    
    aRegion = (IC_XJDRegion*) malloc(sizeof(IC_XJDRegion));

    aRegion->myname = (char*) strdup(myname);
    aRegion->partnername = (char*) strdup(partnername);
    
    aRegion->my_region_name = (char*) strdup(my_region_name);
    aRegion->partner_region_name = (char*) strdup(partner_region_name);
    aRegion->type = (char*) strdup(type);
    aRegion->commtype = (char*) strdup(commtype);
    
    aRegion->me = (IC_Program*) NULL;
    aRegion->partner = (IC_Program*) NULL;
    
    aRegion->tag = tag;
    aRegion->region = (IC_Region**) NULL; /* filled later.*/
    aRegion->rgn_size = 0; /* filled later.*/
    
    aRegion->rgn_desc = (IC_Desc*) NULL; /* filled later.*/
    aRegion->sched = (IC_Sched*) NULL;   /* filled later.*/
    aRegion->local_data = (void*) NULL;  /* filled later.*/

    aRegion->next = (IC_XJDRegion*) NULL;
        
    add_region((IC_XJDRegion*) aRegion, xjd);
}
                                

char* search_pname_byID(char* id, IC_XJD* xjd){
    ezxml_t curComp;
    ezxml_t cid, tmp;
    IC_XJDComponent* aComp;
   
    curComp = get_first_comp(xjd->xmlRoot);
    
    while(curComp){
        cid = ezxml_child(curComp, COMPID);
        tmp = ezxml_child(curComp, COMPNAME);

        if( !strcmp(cid->txt, id) ){
            return tmp->txt;
        }

        curComp = curComp->next;
    }

    return NULL;
}
    
IC_Program* search_program(char* name, IC_XJD* xjd){
    IC_XJDComponent* tmp = xjd->cHeader;
    
    while(tmp){
        if( !strcmp(tmp->name, name) ){
            return tmp->comp;
        }
        tmp = tmp->next;
    }
    
    return NULL;
}


IC_XJDRegion* search_region(char* name, IC_XJD* xjd){
    IC_XJDRegion* tmp = xjd->rHeader;
    
    while(tmp){
        if( !strcmp(tmp->my_region_name, name) ){
            return tmp;
        }
        tmp = tmp->next;
    }
    
    return NULL;
}


void add_comp(IC_XJDComponent* comp, IC_XJD* xjd){
    if( xjd->cHeader == NULL ){
        xjd->cHeader = comp;
        xjd->cTail   = comp;
    }
    else{
        xjd->cTail->next = comp;
        xjd->cTail = comp;
    }
}


void add_region(IC_XJDRegion* region, IC_XJD* xjd){
    if( xjd->rHeader == NULL){
        xjd->rHeader = region;
        xjd->rTail = region;
    }
    else{
        xjd->rTail->next = region;
        xjd->rTail = region;
    }
}


void print_components(IC_XJD* xjd){
    IC_XJDComponent* tmp = (IC_XJDComponent*) xjd->cHeader;
    
    fprintf(stdout, "======= COMPONENT LIST =======\n");
    while(tmp){
        print_comp(tmp);
        tmp = (IC_XJDComponent*) tmp->next;
    }
}


void print_comp(IC_XJDComponent* tmp ){
    fprintf(stderr, "  Name: %s\n  Task: %d\n", \
                            tmp->name, tmp->ntask);
    if(tmp->comp){
        fprintf(stderr, "  Comp: %s\n\n", tmp->comp->name);
    }
    else{
        fprintf(stderr, "\n");
    }
}    
    

void print_regions(IC_XJD* xjd){
    int i;
    IC_XJDRegion* tmp = (IC_XJDRegion*) xjd->rHeader;
    
    fprintf(stdout, "========= REGION LIST =========\n");
    while(tmp){
        print_region(tmp);
        tmp = (IC_XJDRegion*) tmp->next;
    }
}

void print_region(IC_XJDRegion* tmp ){
    int i;
    
    if(tmp->me && tmp->partner){
        fprintf(stdout, "  Me: %s %d\n  Other: %s %d\n  MyRgn: %s\n  OtherRgn: %s\n  RgnType: %s\n", \
                            tmp->me->name, tmp->me->nbNode, \
                            tmp->partner->name, tmp->partner->nbNode, \
                            tmp->my_region_name, \
                            tmp->partner_region_name, \
                            tmp->type );
                                
        for ( i=0 ; i<tmp->rgn_size ; i++){
            fprintf(stdout, "  RgnSize: %d\n  RgnType: %d", tmp->region[i]->size, tmp->region[i]->type);
        }                                
    }
    else{
        fprintf(stdout, "  Me: %s \n  Other: %s \n  MyRgn: %s\n  OtherRgn: %s\n  RgnType: %s\n", \
                            tmp->myname, tmp->partnername, \
                            tmp->my_region_name, \
                            tmp->partner_region_name, \
                            tmp->type );
    }        
    fprintf(stdout, "\n");
}


int parse_param(int argc, char **argv, char** xjd){
    int c;
    int dflag = 0;

    optind = 1; /* reset option index to 1 to parse from the first option*/
   
    while ((c = getopt (argc, argv, "m:n:d:")) != -1){
        switch(c){
            case 'd':
                *xjd = strdup(optarg);
                dflag = 1;
                break;
        }
    }

    if(!dflag){
        return -1;
    }
    else{
        return 0;
    }
}

ezxml_t read_xjd(const char* xjdname){
    FILE* fp; 
   
    if ((fp = fopen(xjdname, "r")) == NULL){
        fprintf(stderr, "Cannot open %s\n", xjdname);
        return NULL;
    }
            
    return ezxml_parse_fp(fp);
}


void free_xjd(ezxml_t xmlRoot){ 
    ezxml_free(xmlRoot);
}

char* get_version(ezxml_t xmlRoot){
    return ezxml_child(xmlRoot, XJDVERSION)->txt;
}

ezxml_t get_first_comp(ezxml_t xmlRoot){
    ezxml_t plist = ezxml_child(xmlRoot, COMPLIST);
    return ezxml_child(plist, COMP);
}

ezxml_t get_first_conn(ezxml_t xmlRoot){
    ezxml_t clist = ezxml_child(xmlRoot, CONNLIST);
    return ezxml_child(clist, CONN);
}


