! program to test XJD-based high-level Intercomm interface
! Il-Chul Yoon : 01/11/2006
! Modified by Norman Lo: 04/15/2006
program intercomm_test

! using InterComm
  use intercomm_interface
  use array_printing

  implicit none

! array and variable declarations
  integer, dimension (3,4,5) :: SMALL
  integer, dimension (3,10,10) :: INTEGERS
  double precision, dimension (10,10) :: DOUBLES
  real, dimension (10) :: REALS
  integer :: i, j, k, ic_err
  integer broad(10)


! declaring InterComm endpointset object
  type(ic_obj) :: epset 

! initialize arrays
  do k = 1, 3
    do i = 1, 10
      REALS(i) = 10*(i-1)
      do j = 1, 10
        DOUBLES(i,j) = 10*(i-1)+(j-1)
        INTEGERS(k,i,j) = 500*k+(10*(i-1)+(j-1))
      end do
    end do
  end do

  do k = 1, 3
    do i = 1, 4
      do j = 1, 5
        SMALL(k,i,j) = 500*k+(10*(i-1)+(j-1))
      end do
    end do
  end do


! creating communication endpoint set
  call ic_endpointset_constructor(epset,'hif90ex.xjd'//CHAR(0),'left'//CHAR(0),ic_err);


! testing if communication array is in a sane state
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_endpointset_constructor'//CHAR(0),ic_err)
    stop
  end if

! Broadcasting
  do i = 1,10
    broad(i) = i*5
  end do

  call ic_bcast_local_array(epset, 'broad1'//CHAR(0), broad, 10, ic_err)
  print *, "lexample.f90 >> Broadcasting successfully"

  call printArray(SMALL)

  call ic_register_array(epset, 'small1'//CHAR(0), SMALL(:,1:4:2,1:5:2), ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_register_array'//CHAR(0), ic_err)
    stop
  end if

  call ic_commit_arrays(epset, ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_commit_arrays'//CHAR(0), ic_err)
    stop
  end if

  call ic_export_array(epset, 'small1'//CHAR(0), 1002, ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_export_array'//CHAR(0), ic_err)
    stop
  end if



!  call ic_export_array(ic,SMALL(:,:,:), 1002, ic_err)

!  call ic_export_array(ic,SMALL(1:1,:,:), 1002, ic_err)
!  call ic_export_array(ic,SMALL(:,1:1,:), 1002, ic_err)
!  call ic_export_array(ic,SMALL(:,:,1:1), 1002, ic_err)

!  call ic_export_array(ic,SMALL(1:1,1:1,:), 1002, ic_err)
!  call ic_export_array(ic,SMALL(1:1,:,1:1), 1002, ic_err)
!  call ic_export_array(ic,SMALL(:,1:1,1:1), 1002, ic_err)

!  call ic_export_array(ic,SMALL(:,1:3,1:4), 1002, ic_err)
!  call ic_export_array(ic,SMALL(1:2,:,1:4), 1002, ic_err)
!  call ic_export_array(ic,SMALL(1:2,1:3,:), 1002, ic_err)
 
!  call ic_export_array(ic,SMALL(1:1,1:1,1:1), 1002, ic_err)
!  call ic_export_array(ic,SMALL(3:3,4:4,5:5), 1002, ic_err)

!  call ic_export_array(ic,SMALL(1:2,:,:), 1002, ic_err)
!  call ic_export_array(ic,SMALL(:,1:3,:), 1002, ic_err)
!  call ic_export_array(ic,SMALL(:,:,1:4), 1002, ic_err)
!  call ic_export_array(ic,SMALL(1:2,1:3,1:4), 1002, ic_err)

!  call ic_export_array(ic,SMALL(:,2:3,2:4), 1002, ic_err)

!  call ic_export_array(ic,SMALL(1:3:2,1:4:3,1:5:2), 1002, ic_err)
!  call ic_export_array(ic,SMALL(1:3,1:4:3,1:5:2), 1002, ic_err)




!!  print *,">>>> dealing with a 2D double precision array"
!!!!!!!!!!!!!!!!!!!!! dealing with a 2D double precision array
!!  call printArray(DOUBLES)
!!
!!  call ic_export_array(ic,DOUBLES(1:10:3, 1:9:2), 1002, ic_err); 
!!  if (ic_err /= IC_OK) then
!!    call ic_print_error_message('ic_export_array'//CHAR(0), ic_err)
!!    stop
!!  end if
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  call ic_export_array(ic,DOUBLES(2:5,4:9), 1003, ic_err); 
!!  if (ic_err /= IC_OK) then
!!    call ic_print_error_message('ic_export_array'//CHAR(0), ic_err)
!!    stop
!!  end if
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *, ""

!!  print *,">>>> dealing with a 1D array of reals"
!!!!!!!!!!!!!!!!!!!!! dealing with a 1D array of reals
!!  call printArray(REALS)
!!  print *,"subarray"
! communicating parts of the REALS array 
!!  call ic_dump_array_info(REALS(2:6)); 
!!  call printArray(REALS(2:6)); 
! exporting array section to "right" side application
!!  call ic_export_array(ic,REALS(2:6), 1001, ic_err); 
!!  if (ic_err /= IC_OK) then
!!    call ic_print_error_message('ic_export_array'//CHAR(0), ic_err)
!!    stop
!!  end if

!!!!!!!!!!!!!!!!!!!!! dealing with a 3D array of integers
!!  call printArray(INTEGERS)
!!  print *,"subarray"
! communicating parts of the INTEGERS array 
!!  call ic_dump_array_info(INTEGERS(1:2,2:5,4:9));
!!  call printArray(INTEGERS(1:2,2:5,4:9));
! exporting array section to "right" side application
!!  call ic_export_array(ic,INTEGERS(1:2,2:5,4:9), 1003, ic_err); 
!!  if (ic_err /= IC_OK) then
!!    call ic_print_error_message('ic_export_array'//CHAR(0), ic_err)
!!    stop
!!  end if

! destroying communication endpoint set
  call ic_endpointset_destructor(epset);
  print *,"done"

end program intercomm_test
