! program to test XJD-based high-level Intercomm interface
! Henrique - 9/3/2003
! Modified by Norman Lo: 04/15/2006
program intercomm_test

  use intercomm_interface
  use array_descriptor
  use array_printing

  implicit none

  integer, dimension (3,4,5) :: SMALL
  integer, dimension (3,10,10) :: INTEGERS
  double precision, dimension (10,10) :: DOUBLES
  real, dimension (10) :: REALS
  integer :: i, j, k, ic_err
  integer broad(10)
  integer test
  data test / 1 /

  type(ic_obj) :: epset
  type(arraydesc) :: INTEGERSDesc

  ! initialize small array
  do k = 1, 3
    do i = 1, 10
      REALS(i) = 100+(10*(i-1))
      do j = 1, 10
        DOUBLES(i,j) = 100+(10*(i-1)+(j-1))
        INTEGERS(k,i,j) = 100*(k-1)+(10*(i-1)+(j-1))
      end do
    end do
  end do

  do k = 1, 3
    do i = 1, 4
      do j = 1, 5
        SMALL(k,i,j) = 100*k+(10*(i-1)+(j-1))
      end do
    end do
  end do


! creating communication endpoint set
  call ic_endpointset_constructor(epset,'hif90ex.xjd'//CHAR(0),'right'//CHAR(0),ic_err);

! testing if communication array is in a sane state
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_endpointset_constructor'//CHAR(0),ic_err)
    stop
  end if

! Receiving broadcast
  call ic_recv_local_array(epset, 'broad2'//CHAR(0), broad, 10, ic_err)

  do i=1,10
    if (broad(i) /= i*5) then
       test = 0
    end if
  end do

  if (test == 1) then
    print *, "rexample.f90 >> Received broadcast successfully"
  else if (test == 0) then
    print *, "rexample.f90 >> Received broadcast FAILED"
  end if

    

  call printArray(SMALL)
  
  call ic_register_array(epset, 'small2'//CHAR(0), SMALL(:,2:3,2:4), ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_register_array'//CHAR(0), ic_err)
    stop
  end if

  call ic_commit_arrays(epset, ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_commit_arrays'//CHAR(0), ic_err)
    stop
  end if

  call ic_import_array(epset, 'small2'//CHAR(0), 1002, ic_err)
  if (ic_err /= IC_OK) then
    call ic_print_error_message('ic_export_array'//CHAR(0), ic_err)
    stop
  end if


!  call ic_import_array(ic,SMALL(:,:,:), 1002, ic_err)

!  call ic_import_array(ic,SMALL(1:1,:,:), 1002, ic_err)
!  call ic_import_array(ic,SMALL(:,1:1,:), 1002, ic_err)
!  call ic_import_array(ic,SMALL(:,:,1:1), 1002, ic_err)

!  call ic_import_array(ic,SMALL(1:1,1:1,:), 1002, ic_err)
!  call ic_import_array(ic,SMALL(1:1,:,1:1), 1002, ic_err)
!  call ic_import_array(ic,SMALL(:,1:1,1:1), 1002, ic_err)

!  call ic_import_array(ic,SMALL(:,1:3,1:4), 1002, ic_err)
!  call ic_import_array(ic,SMALL(1:2,:,1:4), 1002, ic_err)
!  call ic_import_array(ic,SMALL(1:2,1:3,:), 1002, ic_err)

!  call ic_import_array(ic,SMALL(1:1,1:1,1:1), 1002, ic_err)
!  call ic_import_array(ic,SMALL(3:3,4:4,5:5), 1002, ic_err)

!  call ic_import_array(ic,SMALL(1:2,:,:), 1002, ic_err)
!  call ic_import_array(ic,SMALL(:,1:3,:), 1002, ic_err)
!  call ic_import_array(ic,SMALL(:,:,1:4), 1002, ic_err)
!  call ic_import_array(ic,SMALL(1:2,1:3,1:4), 1002, ic_err)

!  call ic_import_array(ic,SMALL(:,2:3,2:4), 1002, ic_err)

!  call ic_import_array(ic,SMALL(1:3:2,1:4:3,1:5:2), 1002, ic_err)
!  call ic_import_array(ic,SMALL(1:3,1:4:3,1:5:2), 1002, ic_err)

  call printArray(SMALL)


!!  print *,">>>> dealing with a 2D double precision array"
!!  print *,"before receiving data:"
!!  call printArray(DOUBLES)
!!  call ic_import_array(ic,DOUBLES(1:10:3, 1:9:2), 1002, ic_err);
!!  if (ic_err /= IC_OK) then
!!    call ic_print_error_message('ic_import_array'//CHAR(0), ic_err)
!!    stop
!!  end if
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *,"after receiving data:"
!!  call printArray(DOUBLES)

  ! initialize small array
!!  do k = 1, 3
!!    do i = 1, 10
!!      REALS(i) = 100+(10*(i-1))
!!      do j = 1, 10
!!        DOUBLES(i,j) = 100+(10*(i-1)+(j-1))
!!        INTEGERS(k,i,j) = 100*(k-1)+(10*(i-1)+(j-1))
!!      end do
!!    end do
!!  end do

!!  call ic_import_array(ic,DOUBLES(2:5,4:9), 1003, ic_err);
!!  if (ic_err /= IC_OK) then
!!    call ic_print_error_message('ic_import_array'//CHAR(0), ic_err)
!!    stop
!!  end if
!!  print *,"after receiving data:"
!!  call printArray(DOUBLES)

!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *, ""
!!  print *, ""


!!  print *,">>>> dealing with a 1D double precision array"
!!!!!!!!!!!!!!!!!!!!! dealing with a 1D array of reals
!!  print *,"before receiving data:"
!!  call printArray(REALS)
!!  call ic_import_array(ic,REALS(2:6), 1001, ic_err);
!!  if (ic_err /= IC_OK) then
!!    call ic_print_error_message('ic_import_array'//CHAR(0), ic_err)
!!    stop
!!  end if
!!  print *,"after receiving data:"
!!  call printArray(REALS)

!!  print *,">>>> dealing with a 3D double precision array"
!!!!!!!!!!!!!!!!!!!!! dealing with a 3D array of integers
!!  print *,"before receiving data:"

!!  call printIntegerArray(INTEGERSDesc)
!  call ic_dump_array_info(INTEGERS); 
!!  call ic_import_array(ic,INTEGERS(2:3,1:4,3:8), 1003, ic_err);
!!  if (ic_err /= IC_OK) then
!!    call ic_print_error_message('ic_importarray'//CHAR(0), ic_err)
!!    stop
!!  end if
!!  print *,"after receiving data:"
!!  call printIntegerArray(INTEGERSDesc)
!  call printArray(INTEGERS)

  call ic_endpointset_destructor(epset);
  print *,"done"
end program intercomm_test
