#include <stdio.h>
#include <memory.h>

#include "comm.h"
#include "parti.h"

#include "port.h"

#include "chaos_deref.h"

#include "util.h"
#include "boolean.h"

/*************************************/
#include "../GENERAL/general_bsparti.h"

#include "../../BLOCK_PARTI/BlockParti_Dereference_HPFRegion_Local.h"
#include "../../BLOCK_PARTI/BlockParti_Dereference_HPFRegion_Global.h"


/*************************************/


#include "../coupling2.h"


#define INIT_MSG 2000

/* -----Some Constants and Prototypes ------------------------------------- */
/* 
** Block Parti 
*/


/*
** Chaos
*/
#define CH_DIM 100 /* I allocate the maximum size */

region_s *
Alloc_RangeRegion
_AnsiC_((
	 int  size ,
	 int *index
	 ));

void
set_CH_indices 
_AnsiC_(( 
int NbTotalElem,
int *local_index_array,
int *size_local_index_array,
pgme_s *pgme
));

/******************************/
DARRAY *
BP_create_darray  /* returns a pointer to a distributed array descriptor */
_AnsiC_(( 
         int w, int h
         ));


int DistributeRegularly();



/* ------------------------------------------------------------------------ */
/************************/
int Print_LZ_Info_2D(int* left, int* right, int* stride,int LZ_count
,int BP_DIM1,int BP_DIM2)
{

  int i,j,k;
  
  printf("REGION INFO(LINEARIZATION) Values --------- \n");
  for(i = left[0]; i <=right[0]; i++)
    for(j = left[1]; j <=right[1]; j++)
        {
          printf(" LZ[%d] = %d \n",LZ_count, i* BP_DIM2 + j);
          LZ_count++;
        }
  return LZ_count;

}




/* ------------------------------------------------------------------------ */

main(int nb_arg,char **arg)
{
 char *pgme_name="Pgme2";
  char *other_pgme_name="Pgme1";
  pgme_s *my_pgme;
  pgme_s *other_pgme;
  int numNode_other;
  int me=-1;
  int numNode=-1;

  DARRAY *BP_da    ;
  int BP_DIM1, BP_DIM2;
  int BP_DIM3 =1 ; /* garbage(for compiling ) */
  double *BP_array   ;
  int gb1,gb2;
  int i,j,k;
  int size[BP_Ndim]; 
  
  region_s *r;
  setOfRegion_s *BP_Set;
  
  
  int left[BP_Ndim];
  int right[BP_Ndim];
  int stride[BP_Ndim];
  int numproc;
  int da_size[BP_Ndim];

  boolean compute_remapping=true;
  boolean new_iteration    =true;
  
  sched_s *sched;
  sched_s *sched_new;
  sched_s *copy_sched;

  decomp_Birreg* irr_dd;
  
  int IterationCounter=0;
  
  int SetRegionOverAllSize;
  int OverAllSize;

  int LZ_count;
  //BP_DIM1 = BP_DIM2 = 4;
  //   BP_DIM1 = BP_DIM2 = 12;
   BP_DIM1 = BP_DIM2 = 14;
   // BP_DIM1 = BP_DIM2 = 256;
  if (nb_arg < 3) {
    printf("Usage main1 #replicate #friends\n");
    exit(1);
  }
 
  numNode_other= atoi(arg[2]);
  if (numNode_other <= 0 || atoi(arg[1]) <= 0) {
    printf("Wrong value for one of the params\n");
    exit(1);
  }
  
  /*
  ** What is the current librarie version 
  */
  printf("\n Version %s \n", Version());
  // numNode=start_master_slave1(arg);
  numNode=start_master_slave(arg);
  //  fprintf(stderr,"After start\n");
  /*
   ** Initialise 
   **    the pvm library
   **    the chaos library
   */
  parti_pvm_setup(numNode,100,pgme_name);
  // fprintf(stderr,"after pvm setup\n");
  PARTI_setup();
  //fprintf(stderr,"after setup\n");
  
  /*
  ** Initialise the pgme structure 
  ** who am i, who are the other nodes ...
   */
  
  my_pgme=InitPgme("Truc2",numNode);
  //fprintf(stderr,"after init mypgme %d %d\n",numNode, numNode_other);
  other_pgme=WaitPgme("Truc1",numNode_other);
  //fprintf(stderr,"after wait other pgme\n");

  /*
  ** pvm inquiries
  */
  numproc = NumNodePgme(my_pgme);
  me=MyPosMyPgme();
  printf("\n me(main1)=%i ",me);
  
  init_timers();
  Sync2Pgme(my_pgme,other_pgme);
  fprintf(stderr,"main1 %d Initialized\n", me);
  
  /*
   ** Create a DAD for Block Parti
   */
  
  BP_da=BP_create_darray(BP_DIM1, BP_DIM2);
  
  /*
   ** Allocate and initialize the BP_array
   */
  laSizes(BP_da,da_size);

  printf("Returned !!!!!!!!!!!!!!!!!!!!!%d %d\n", da_size[0], da_size[1]);  
  
  BP_array=(double *) malloc(sizeof(double)*da_size[0]*da_size[1]);
  
  /* Initialize : to make sure that areas not in regions doesn't change */

  // initialize when MB is a receiver
  /*
  {
    int i;
    for (i=0; i<da_size[0]*da_size[1]; i++)
      BP_array[i] = -9999.0;
  }
  */
  irr_dd = DARRAY2BirregTree(BP_da);
  
  
  // initialize when MB is a sender..
   {
    int i,j,k,m;
    int index =0;
    
    int num_blocks;
    leaf_Node** block_array1;
    int num_my_blocks;
    block** my_blocks;
    
    num_blocks = get_num_of_blocks(irr_dd); 
    block_array1 = (leaf_Node**)malloc(num_blocks * sizeof(leaf_Node*));
    store_block_array_ptr(irr_dd,block_array1);
    my_blocks = get_my_blocks(me, block_array1, num_blocks, &num_my_blocks,2);
    for(i =0; i < num_my_blocks; i++)
      {
        for(j = my_blocks[i]->start_global[0];  j <=  my_blocks[i]->end_global[0]; j++)
          for(k = my_blocks[i]->start_global[1];  k <=  my_blocks[i]->end_global[1]; k++)
              {
                BP_array[index++] = j*BP_DIM2 + k;
              }
      }
  }



  /*
  ** create the SetOfRegion for BP
  */
  BP_Set=Alloc_setOfRegion();
  LZ_count = 0;
  
  /********************** 1 region  ***********************/
  /*
    // 4X4
    left [0]=0            ;  left[1]=0             ;
    right[0]=BP_DIM1-1    ;  right[1]= BP_DIM2-1   ;
    stride[0]=1           ;  stride[1]=1           ;
   

    r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
    Add_Region_setOfRegion(r,BP_Set);
  */
  
  /********************** 3 regions  ***********************/
  
  /*
  // 12X12
  left [0]=0            ;  left[1]=0             ;
  right[0]=3            ;  right[1]= 2 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=1            ;  left[1]=3             ;
  right[0]=4           ;  right[1]=5 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=0            ;  left[1]=7             ;
  right[0]=BP_DIM1-1    ;  right[1]=BP_DIM2-1 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  */
  
  /*****************************************************************/

  // 14X14

  left [0]=12            ;  left[1]=0             ;
  right[0]=13            ;  right[1]= 4 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=0            ;  left[1]=4             ;
  right[0]=11           ;  right[1]=6 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=4            ;  left[1]=1             ;
  right[0]=4            ;  right[1]=1 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);


  left [0]=5            ;  left[1]=1             ;
  right[0]=5            ;  right[1]= 1 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=3            ;  left[1]=1             ;
  right[0]=3           ;  right[1]=1 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=13            ;  left[1]=12             ;
  right[0]=13    ;  right[1]=13 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);

  left [0]=0            ;  left[1]=9             ;
  right[0]=13            ;  right[1]= 9 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=2            ;  left[1]=7             ;
  right[0]=5           ;  right[1]=8 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);

 

  /********************** 4 regions (256x256) ***********************/
  /*
  // 1/2

  left [0]=0            ;  left[1]=0             ;
  right[0]=199            ;  right[1]= 31 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=5            ;  left[1]=70             ;
  right[0]=104           ;  right[1]=169 ;
  stride[0]=1           ;  stride[1]=1           ;
  
 
  
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);

  left [0]=220            ;  left[1]=20             ;
  right[0]=251    ;  right[1]=219 ;
  stride[0]=1           ;  stride[1]=1           ;

  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  


  left [0]=110            ;  left[1]=150             ;
  right[0]=209    ;  right[1]=249 ;
  stride[0]=1           ;  stride[1]=1           ;

  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  */
  
  /*
    // small size region. less than proc num 
  left [0]=0            ;  left[1]=0             ;
  right[0]=2    ;  right[1]=0 ;
  stride[0]=1           ;  stride[1]=1           ;

  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  */


  /********************** 4 regions (256x256) ***********************/
  /*
  // 1/4 
  left [0]=0            ;  left[1]=0             ;
  right[0]=99            ;  right[1]= 31 ;
  stride[0]=1           ;  stride[1]=1           ;
 
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  
  left [0]=5            ;  left[1]=70             ;
  right[0]=104           ;  right[1]=119 ;
  stride[0]=1           ;  stride[1]=1           ;
  
 
  
  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);

  left [0]=220            ;  left[1]=20             ;
  right[0]=251    ;  right[1]=119 ;
  stride[0]=1           ;  stride[1]=1           ;

  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  


  left [0]=110            ;  left[1]=150             ;
  right[0]=159    ;  right[1]=249 ;
  stride[0]=1           ;  stride[1]=1           ;

  r=Alloc_R_HPF(2,left,right,stride,R_replicated,Mem_Copy);
  Add_Region_setOfRegion(r,BP_Set);
  

  */


/*****************************************************************/

  // send a garbage message to other pgme(all nodes)

  for(i = 0; i < numNode_other ; i++)
    {
      pvm_recv(TidPgme(other_pgme,i), INIT_MSG);
      pvm_upkint(&gb1,1,1);
      pvm_upkint(&gb2,1,1);
      
      printf("gb %d %d \n", gb1,gb2);
    }
  gb1 =110*me;
  gb2 =1100*me;;
  
  // receive a garbage message from other pgme(all nodes)
  for(i = 0; i < numNode_other ; i++)
    {
      pvm_initsend(PvmDataDefault);
      pvm_pkint(&gb1,1,1);
      pvm_pkint(&gb2,1,1);
      pvm_send(TidPgme(other_pgme,i),INIT_MSG);
    }
  
  Sync2Pgme(my_pgme,other_pgme); 
 
/**************************************************/

  // send a garbage message to my pgme(all nodes)
  for(i = 0; i < numproc ; i++)
    {
      pvm_initsend(PvmDataDefault);
      pvm_pkint(&gb1,1,1);
      pvm_pkint(&gb2,1,1);
      pvm_send(TidPgme(my_pgme,i),INIT_MSG);
    }

  gb1 = 100 * me +7;
  gb2 = 1000 * me + 88;
  
  // receive a garbage message from my pgme(all nodes)
  for(i = 0; i < numproc ; i++)
    {
      pvm_recv(TidPgme(my_pgme,i), INIT_MSG);
      pvm_upkint(&gb1,1,1);
      pvm_upkint(&gb2,1,1);
      
      printf("gb %d %d \n", gb1,gb2);
    }

  Sync2Pgme(my_pgme,other_pgme); 
  
  start_timer_1(1);
  
  OverAllSize=SizeSetOfRegion(BP_Set);
  
  /***********************New Compute Schedules *****************/
  // 4 cases depending on sending a DD and receiving schedules
  
  // fprintf(stderr,"New compute schedule main2(%d)\n",me); 
   
  

  // all nodes are responsible for some other nodes

  //  sched_new = NewComputeScheduleOnMB(Regular, SendAllToAll,SendBackAll,irr_dd,BP_Set,my_pgme,other_pgme, OverAllSize);
  
  
  // sched_new = NewComputeScheduleOnMB(Regular, SendAllToAll,SendBackPart, irr_dd,BP_Set,my_pgme,other_pgme, OverAllSize);
  
  

   // a repr sends dd 
   
  //  sched_new = NewComputeScheduleOnMB(Regular, SendOneToOne,SendBackAll,irr_dd,BP_Set,my_pgme,other_pgme, OverAllSize);
  
  
  sched_new = NewComputeScheduleOnMB(Regular, SendOneToOne,SendBackPart, irr_dd,BP_Set,my_pgme,other_pgme, OverAllSize);
  
    // fprintf(stderr,"end ofNew compute schedule main2(%d)\n",me); 
   

  /***************************************************/

   // print new schedules
   
   /*
     fprintf(stderr," me = %d ---- (New)print schedules(main1)\n\n", me);
     PrintSched(sched_new);
     fprintf(stderr," me = %d ---- (New)End of print schedules(main1)\n\n", me);
   */
   
   /*******************Old Compute Schedules *********************/
   
   //  fprintf(stderr,"Before \n");
  
  // when MB is a sender..

  //sched =ComputeScheduleForSender(ComputeOnReceiver,my_pgme,BP_da,BP_Set,other_pgme,BlockParti_Dereference_HPFRegion_Local,DistributeRegularly,&OverAllSize,DoNotOptComm);
  



  // when MB is a receiver
  //  sched =ComputeScheduleForReceiver(ComputeOnReceiver,my_pgme,BP_da,BP_Set,other_pgme,BlockParti_Dereference_Offset_HPFSetOfRegion_Global,DoNotOptComm);

   /*
    // print old schedules 
    fprintf(stderr," me = %d ---- (Old)print schedules(main1)(MB.receive)\n\n", me);
    PrintSched(sched);
    fprintf(stderr," me = %d ---- (Old)End of print schedules(main1.MB.receive)\n\n", me);
   */
   
   //   stop_timer(1);
   
   //fprintf(stderr,"before sync1\n");
  // Sync2Pgme(my_pgme,other_pgme); 
  
   stop_timer(1);
   /*****************  Receive(Send) ***************************/
 
   
   Sync2Pgme(my_pgme,other_pgme); 
   start_timer_1(2);
   //fprintf(stderr,"before recev\n");
    
   /*  
   // Receiver
   
   dDataMoveRecv(other_pgme,sched_new,BP_array,1001);     
   //dDataMoveRecv(other_pgme,sched,BP_array,1001); 
   */
   
   // Sender
   
   dDataMoveSend(other_pgme,sched_new,BP_array,1001);
   //dDataMoveSend(other_pgme,sched,BP_array,1001);
   
  
       stop_timer(2);
   
   Sync2Pgme(my_pgme,other_pgme);

   //  stop_timer(2);
   /************************************************************/
   /* Printing local array after receiving */
   /*
     {
    int i;
    
    printf("me(main2)= %d array sizes %d %d\n",me , da_size[0], da_size[1]);
    
    for (i=0; i<da_size[0]*da_size[1]; i++)
      printf("El %d = %f\n", i, BP_array[i] );
  
    
      }
   */
  /************************************************************/
 
  /* Printing whole array after collecting data items */
   /*  

   {
    int num_blocks;
    int nDims;
    leaf_Node** block_array;
    double** buffer_array;
    int i,j,k,m;
    int size;
    int num_elements;
    int local_index;
    double* whole_array;
    
    if(me == 0) {
      num_blocks = get_num_of_blocks(irr_dd);
      nDims = irr_dd->nDims;
      block_array = (leaf_Node**)malloc(num_blocks * sizeof(leaf_Node*));
      store_block_array_ptr(irr_dd,block_array);
      buffer_array = (double**)malloc(num_blocks*sizeof(double*));
      
      for(i=0; i < num_blocks; i++)
        {
          if( block_array[i]->proc != me){
            size = 1;
            for( j = 0; j < nDims; j++)
              size *= block_array[i]->size[j];
            
            pvm_recv(TidPgme(my_pgme,block_array[i]->proc),7777);
            
            buffer_array[i] = (double*)malloc(size*sizeof(double));
            pvm_upkdouble(buffer_array[i],size,1);
          }
          else buffer_array[i] = 0;
        }
      
      if(nDims ==2) 
        num_elements =BP_DIM1*BP_DIM2;
      
      if(nDims ==3) 
        num_elements =BP_DIM1*BP_DIM2*BP_DIM3;
      
      whole_array = (double*)malloc(num_elements*sizeof(double));
      
      for(i = 0; i < num_blocks; i++)
        { 
          if(nDims == 2) {
            local_index = 0;
            for(j = block_array[i]->start_global[0]; j <= block_array[i]->end_global[0];j++)
              for(k = block_array[i]->start_global[1]; k <= block_array[i]->end_global[1]; k++)
                {
                  if(block_array[i]->proc!= me){
                    whole_array[j*BP_DIM2+k] = buffer_array[i][local_index];
                  }
                  else 
                    whole_array[j*BP_DIM2+k] = BP_array[local_index];
                  
                  local_index++;
                }
          }
          else if(nDims==3) {
            local_index = 0;
            for(j = block_array[i]->start_global[0]; j <= block_array[i]->end_global[0];j++)
              for(k = block_array[i]->start_global[1]; k <= block_array[i]->end_global[1]; k++)
                for(m = block_array[i]->start_global[2]; m <=block_array[i]->end_global[2]; m++)
                  {
                    if(block_array[i]->proc!= me){ 
                      whole_array[j*BP_DIM2*BP_DIM3+k*BP_DIM3+m] = buffer_array[i][local_index];
                    }
                    else {
                      whole_array[j*BP_DIM2*BP_DIM3+k*BP_DIM3+m] = BP_array[local_index];
                    }
                    local_index++;
                  }
          }
        }
      
      printf("----------- Whole Array(After collecting -----\n");
      {
	int count=0;
      for( j = 0; j< num_elements;j++)
        if(whole_array[j] != -9999){
          printf("Elem[%d] = %f\n",j,whole_array[j]);
	  count++;
	}
      fprintf(stderr,"Count = %d\n",count);
      }   

 }
    
    else 
      { 
        nDims = irr_dd->nDims;
        num_elements = 1;

        for(i = 0; i < nDims; i++)
          num_elements *= da_size[i];

        pvm_initsend (GlueEncoding);
        pvm_pkdouble(BP_array,num_elements,1);
        pvm_send(TidPgme(my_pgme,0),7777);
      }  
   }
   */  

  /************* End of Collecting and Printting Data items ********/  
     printf("\n I am the process %d in main2\n",me);
 
  {
    FILE *OutFile;

    FILE *fp_max_scheds;
    FILE *fp_avg_scheds;

    FILE *fp_max_move;
    FILE *fp_avg_move;
    
    int min1,my1,max1,avg1;
    int min2,my2,max2,avg2;
  
    if (me==0)
      {
	OutFile=fopen("/nfshomes/jylee/tempres/resultats_Coupling2_2Pgme.MB.1","a");
	if (OutFile == NULL)
	  {
	    printf("\n /nfshomes/jylee/tempres/resultats_Coupling2_2Pgme.MB.1 not open \n");
	    OutFile=stdout;
	  }
	
	fp_max_scheds = fopen("/nfshomes/jylee/tempres/max_sched.MB.1","a");
        if (fp_max_scheds == NULL)
          {
            printf("\n /nfshomes/jylee/tempres/max_sched.MB.1 not open \n");
            fp_max_scheds=stdout;
          }

        fp_avg_scheds = fopen("/nfshomes/jylee/tempres/avg_sched.MB.1","a");
        if (fp_avg_scheds == NULL)
          {
            printf("\n /nfshomes/jylee/tempres/avg_sched.MB.1 not open \n");
            fp_avg_scheds=stdout;
          }
	
        fp_max_move = fopen("/nfshomes/jylee/tempres/max_move.MB.1","a");
        if (fp_max_move == NULL)
          {
            printf("\n /nfshomes/jylee/tempres/max_move.MB.1 not open \n");
            fp_max_move=stdout;
          }

        fp_avg_move = fopen("/nfshomes/jylee/tempres/avg_move.MB.1","a");
        if (fp_avg_move == NULL)
          {
            printf("\n /nfshomes/jylee/tempres/avg_move.MB.1 not open \n");
            fp_avg_move=stdout;
          }
      }
  
    else
      OutFile=stdout;
    
    fprintf(OutFile,"\n-------------------------------------");
    fprintf(OutFile,"\n BP_Dim %i %i ",BP_DIM1,BP_DIM2);
    fprintf(OutFile,"\n me %i ",me);
    fprintf(OutFile,"\n numproc %i ",NumNodePgme(my_pgme));
    fprintf(OutFile,"\n Niter   ",IterationCounter);
    fprintf(OutFile,"\n Timers ");
    

    min1=return_timer_min(1) ;
    my1=return_timer(1) ;
    max1=return_timer_max(1) ;
    avg1=return_timer_avg(1) ;

    min2=return_timer_min(2) ;
    my2=return_timer(2) ;
    max2=return_timer_max(2) ;
    avg2=return_timer_avg(2) ;
     

    fprintf(OutFile,"\n Compute Sched MB -> Chaos = %8i %8i %8i %8i",
            min1,my1,max1,avg1);
    fprintf(OutFile,"\n remap                  = %8i %8i %8i %8i",
            min2,my2,max2,avg2);

    fprintf(OutFile,"\n-------------------------------------");

    if(me ==0)
      {
	fprintf(fp_max_scheds,"\n%d",max1);
	fprintf(fp_max_move,"\n%d",max2);
	
	fprintf(fp_avg_scheds,"\n%d",avg1);
	fprintf(fp_avg_move,"\n%d",avg2);
      }

    fclose(OutFile);

    if(me == 0)
      {
	fclose(fp_max_scheds);
	fclose(fp_avg_scheds);
	fclose(fp_max_move);
	fclose(fp_avg_move);
      }

  }
  Sync2Pgme(my_pgme,other_pgme);

  if(me==0) pvm_exit();
  
  printf("\n Finished normally in main1(MB)(me = %d)\n",me); 
  
}











