#include <stdio.h>
#include <memory.h>

#include "../../CHAOS/responsable.h"
#include "comm.h"
#include "parti.h"
 
#include "port.h"

#include "chaos_deref.h"
 
#include "util.h"
#include "boolean.h"

#include "../coupling2.h"

#include "../../GENERAL/simple_ttable.h"

/* -----Some Constants and Prototypes ------------------------------------- */
/* 
** Block Parti 
*/

/*
** Chaos
*/

#define INIT_MSG 2000
#define CH_DIM 65536 /* I allocate the maximum size */
//#define CH_DIM 100 

region_s *
Alloc_RangeRegion
_AnsiC_((
	 int  size ,
	 int *index
	 ));

void
set_CH_indices 
_AnsiC_(( 
int NbTotalElem,
int *local_index_array,
int *size_local_index_array,
pgme_s *pgme
));


/* ------------------------------------------------------------------------ */

main(int nb_arg,char **arg)
{
  int gb1,gb2;
  char *pgme_name="Pgme1";
  char *other_pgme_name="Pgme2";
  pgme_s *my_pgme;
  pgme_s *other_pgme;
  int numNode_other;
  int me=-1;
  int numNode=-1;

  TTABLE *CH_ttable;

  double *CH_array;

  int i,j,k;
  int ii,jj;

  region_s *r;
  
  setOfRegion_s *CH_Set;

  boolean compute_remapping=true;
  boolean new_iteration    =true;

  sched_s *sched;
  sched_s *sched_new;
  int  CH_IndexSize; /* Chaos ttable */
  int *CH_Index    ; /* Chaos ttable */
  int numproc;
  int IterationCounter=0;

  int OverAllSize;

  char mesh_name[CH_DIM];
  int *edge_left; 
  int *edge_right;
  int number_edges;

  int res;

  simple_ttable* s_table;

  if (nb_arg < 3) {
    printf("Usage main1 #replicate #friends\n");
    exit(1);
  }
  numNode_other=atoi(arg[2]);
  if (numNode_other <= 0 || atoi(arg[1]) <= 0) {
    printf("Wrong value for one of the params\n");
    exit(1);
  } 
  /*
   ** What is the current librarie version 
   */
  printf("\n Version %s \n", Version());
  // numNode=start_master_slave2(arg);
  numNode=start_master_slave(arg);
  //fprintf(stderr,"After start\n");
  
  /*
   ** Initialise 
   **    the pvm library
   **    the chaos library
   */
  parti_pvm_setup(numNode,100,pgme_name);
  //fprintf(stderr,"after pvm setup\n");
  PARTI_setup();
  //fprintf(stderr,"after setup\n");

  /*
   ** pvm inquiries
   */
  printf("\n me=%i ",me);
  /*
   ** Initialise the pgme structure 
   ** who am i, who are the other nodes ...
   */
  
  //fprintf(stderr,"main2 %d Bef init %d %d\n", me,numNode,numNode_other);
  my_pgme=InitPgme("Truc1",numNode);
  //fprintf(stderr,"main2 %d Bef wait\n", me);
  other_pgme=WaitPgme("Truc2",numNode_other);
  //printf("main2 %d Aft wait\n", me);
  numproc= NumNodePgme(my_pgme);
  
  me=MyPosMyPgme();
  //printf("\n Here me=%i ",me);
  init_timers();
  Sync2Pgme(my_pgme,other_pgme);

  fprintf(stderr,"main2 %d Initialized\n", me);
  /*
  ** I do a maximum memory allocation for chaos indices (ia)
  */
  CH_IndexSize=0;
  CH_Index=(int *)malloc(sizeof(int)*CH_DIM);
  /* 
  ** create the translation table 
  */ 
  set_CH_indices(CH_DIM,CH_Index,&CH_IndexSize,my_pgme);
  CH_ttable=build_translation_table(1,CH_Index,CH_IndexSize); 
  //printf("CCCCCCCCCCCCCCCCCCC %d \n\n",CH_IndexSize);
  s_table =translate_ttable(CH_ttable, numproc, me, CH_DIM);
 
  /* 
   ** I allocate the maximum size of the Chaos Array
   ** and I initialise it to 0
   */
  CH_array=(double *)malloc(sizeof(double)*CH_DIM);
  InitDouble(CH_array,CH_DIM);
  
  
 
  /* Initialization */
  for (i=0; i< CH_DIM; i++)
    {
      // when Chaos is a sender
      //    CH_array[i] = i* numproc + me;
      
      // when  Chaos is a receiver
      CH_array[i] = -9999.0;
    }
  
  
  /*
  ** create the SetOfRegion for Chaos
  */
  CH_Set=Alloc_setOfRegion();

  /*  r=Alloc_RangeRegion(1,CH_DIM);*/
  
  /*
    // 4X4 case, 1 region
    r=Alloc_RangeRegion(1,16);
    Add_Region_setOfRegion(r,CH_Set);
  */
  
  
  /*
    // 12X12, 1 continuous region
    r=Alloc_RangeRegion(1,84);
    Add_Region_setOfRegion(r,CH_Set);
  */

 
  /*
    // 12X12, 3 consecutive regions,total size= 84
    
    r=Alloc_RangeRegion(1,21);
    Add_Region_setOfRegion(r,CH_Set);
    r=Alloc_RangeRegion(22,25); //22~46
    Add_Region_setOfRegion(r,CH_Set);
    r=Alloc_RangeRegion(47,38); //47~84
    Add_Region_setOfRegion(r,CH_Set);
    
  */


  // 14X14, 4 regions, a complex ex(for correctness), size=73

  r=Alloc_RangeRegion(1,7);
  Add_Region_setOfRegion(r,CH_Set);
  r=Alloc_RangeRegion(42,30);
  Add_Region_setOfRegion(r,CH_Set);
  r=Alloc_RangeRegion(17,23); 
  Add_Region_setOfRegion(r,CH_Set);
  r=Alloc_RangeRegion(409,13); 
  Add_Region_setOfRegion(r,CH_Set);


  /*
  // 1/2
  //    256X256, 3 regions, for experiment, size = 32800
  r=Alloc_RangeRegion(1,30000);
  Add_Region_setOfRegion(r,CH_Set);
  r=Alloc_RangeRegion(40000,2000);
  Add_Region_setOfRegion(r,CH_Set);
  r=Alloc_RangeRegion(50000,800); 
  Add_Region_setOfRegion(r,CH_Set);
  
  */

  /*  
  // 1/4
  //    256X256, 3 regions, for experiment, size = 32800
  r=Alloc_RangeRegion(1,15000);
  Add_Region_setOfRegion(r,CH_Set);
  r=Alloc_RangeRegion(40000,1000);
  Add_Region_setOfRegion(r,CH_Set);
  r=Alloc_RangeRegion(50000,400); 
  Add_Region_setOfRegion(r,CH_Set);
  */

  /*
  // small size region. less than num of procs, size= 3
  r=Alloc_RangeRegion(1,3);
  Add_Region_setOfRegion(r,CH_Set);
  */


  /*
    // Enumerated region

    r=Alloc_R_Enum(NumElem,globalCoord,distribution,mem_type);
    NumElem = 5;
    globalCoord  = {1,2,5,33,7};   
    distribution = R_replicated;
    mem_type     = Mem_Copy;
 

    Add_Region_setOfRegion(r,CH_Set);
  */


  /************************************************/
  // send/receive garbage messages to/from my pgme and other pgme(all nodes involved). to eliminate the overhead of first message passing on pvm.

  gb1 = me*100;
  gb2 = me*1000;
  
  // send to other pgme
  for(i = 0; i < numNode_other ; i++)
    {
      pvm_initsend(PvmDataDefault);
      pvm_pkint(&gb1,1,1);
      pvm_pkint(&gb2,1,1);
      pvm_send(TidPgme(other_pgme,i),INIT_MSG);
    }
 
  // receive from other pgme
  for(i = 0; i < numNode_other ; i++)
    {
      pvm_recv(TidPgme(other_pgme,i), INIT_MSG);
      pvm_upkint(&gb1,1,1);
      pvm_upkint(&gb2,1,1);
      
      printf("gb %d %d \n", gb1,gb2);
    }
  
  Sync2Pgme(my_pgme,other_pgme); 

  /*********************************************/

  // send to my pgme
  for(i = 0; i < numproc ; i++)
    {
      pvm_initsend(PvmDataDefault);
      pvm_pkint(&gb1,1,1);
      pvm_pkint(&gb2,1,1);
      pvm_send(TidPgme(my_pgme,i),INIT_MSG);
    }
 
  gb1 = 100 * me +5;
  gb2 = 1000 * me + 6;
  
  // receive from my pgme
  for(i = 0; i < numproc ; i++)
    {
      pvm_recv(TidPgme(my_pgme,i), INIT_MSG);
      pvm_upkint(&gb1,1,1);
      pvm_upkint(&gb2,1,1);
      
      printf("gb %d %d \n", gb1,gb2);
    }
   
  Sync2Pgme(my_pgme,other_pgme); 
  fprintf(stderr,"main2 %d Bef sched\n", me);
 
  start_timer_1(1);

  OverAllSize = SizeSetOfRegion(CH_Set);
  //fprintf(stderr,"Overall size(CH) =%d\n", OverAllSize);

  /**************************************************/
  

  // New compute-schedule

  // 4 cases depending on sending a DD and receiving schedules

  // all nodes are responsible for some other nodes to send dd
  // sched_new = NewComputeScheduleOnCH(Regular, SendAllToAll,SendBackAll,s_table,CH_Set,my_pgme,other_pgme, OverAllSize);
  
  //  sched_new = NewComputeScheduleOnCH(Regular, SendAllToAll,SendBackPart,s_table,CH_Set,my_pgme,other_pgme, OverAllSize);


  // a repr node sends and receive a dd
  
  // sched_new = NewComputeScheduleOnCH(Regular, SendOneToOne,SendBackAll,s_table,CH_Set,my_pgme,other_pgme, OverAllSize);
  
  //fprintf(stderr,"Before sched\n");
   sched_new = NewComputeScheduleOnCH(Regular, SendOneToOne,SendBackPart,s_table,CH_Set,my_pgme,other_pgme, OverAllSize);
  
  //fprintf(stderr,"After sched\n");
  // print new schedules
  /*
    fprintf(stderr," me = %d ---- (New)print schedules(main2)(CH.send)\n\n", me);
    PrintSched(sched_new);
    fprintf(stderr," me = %d ---- (New)End of print schedules(main2.CH.send)\n\n", me);
 */
    
  // Old compute-schedule 

  /*
  // When chaos is a receiver
 sched=ComputeScheduleForReceiver
     
     (ComputeOnReceiver,
     my_pgme,
     CH_ttable,
     CH_Set,
     other_pgme,
     Chaos_Dereference_Offset_EnumSetOfRegion_Global,
      //     CHAOS_DistributeRegularly,
      //   &OverAllSize,
     DoNotOptComm); 
  */
 

 
/*
     sched=ComputeScheduleForSender
     
     (ComputeOnReceiver,
     my_pgme,
     CH_ttable,
     CH_Set,
     other_pgme,
     Chaos_Dereference_EnumRegion_Local,
     CHAOS_DistributeRegularly,
     &OverAllSize,
     DoNotOptComm); 
  
  */
  // print old schedules
  /*             
   fprintf(stderr," me = %d ---- (Old)print schedules(main2)(CH.send)\n\n", me);
   PrintSched(sched);
   fprintf(stderr," me = %d ---- (Old)End of print schedules(main2.CH.send)\n\n", me);
      
  */ 

  //  stop_timer(1);

    // fprintf(stderr,"before sync2\n");
  //    Sync2Pgme(my_pgme,other_pgme); 
    stop_timer(1);
    //fprintf(stderr,"main2 %d Aft sched\n", me);
 
    Sync2Pgme(my_pgme,other_pgme); 
    start_timer_1(2);
    
    //fprintf(stderr,"before sending\n");


    /*************************************/
    // Data move
    /*  
    // Sender
    
        dDataMoveSend(other_pgme,sched_new,CH_array,1001);
    //      dDataMoveSend(other_pgme,sched,CH_array,1001); 
    */
    
 
    // Receiver

    dDataMoveRecv(other_pgme,sched_new,CH_array,1001);     
    //dDataMoveRecv(other_pgme,sched,CH_array,1001);     
    
    
    // print received data
    {
      int count = 0;
      for(i =0; i < CH_DIM; i++)
	{
	  if(CH_array[i] != -9999.0)
	    {
	      fprintf(stderr,"CH[%d] = %f\n", i, CH_array[i]);
	      count++;
	    }
	}
      fprintf(stderr,"coutn = %d\n",count);
    }


      stop_timer(2);

    Sync2Pgme(my_pgme,other_pgme);
    //stop_timer(2);
    printf("\n I am the process %d in main2\n",me);
    FreeSimpleTable(s_table);
 
    {
      FILE *OutFile;

      FILE *fp_max_scheds;
      FILE *fp_avg_scheds;
      
      FILE *fp_max_move;
      FILE *fp_avg_move;
    
      int min1,my1,max1,avg1;
      int min2,my2,max2,avg2;

      if (me==0)
      {
	OutFile=fopen("/nfshomes/jylee/tempres/resultats_Coupling2_2Pgme.CH.2","a");
	if (OutFile == NULL)
	  {
	    printf("\n /nfshomes/jylee/tempres/resultats_Coupling2_2Pgme.CH.2 not open \n");
	    OutFile=stdout;
	  }
	
	fp_max_scheds = fopen("/nfshomes/jylee/tempres/max_sched.CH.2","a");
        if (fp_max_scheds == NULL)
          {
            printf("\n /nfshomes/jylee/tempres/max_sched.CH.2 not open \n");
            fp_max_scheds=stdout;
          }

        fp_avg_scheds = fopen("/nfshomes/jylee/tempres/avg_sched.CH.2","a");
        if (fp_avg_scheds == NULL)
          {
            printf("\n /nfshomes/jylee/tempres/avg_sched.CH.2 not open \n");
            fp_avg_scheds=stdout;
          }
	
        fp_max_move = fopen("/nfshomes/jylee/tempres/max_move.CH.2","a");
        if (fp_max_move == NULL)
          {
            printf("\n /nfshomes/jylee/tempres/max_move.CH.2 not open \n");
            fp_max_move=stdout;
          }

        fp_avg_move = fopen("/nfshomes/jylee/tempres/avg_move.CH.2","a");
        if (fp_avg_move == NULL)
          {
            printf("\n /nfshomes/jylee/tempres/avg_move.CH.2 not open \n");
            fp_avg_move=stdout;
          }
      }
    else
      OutFile=stdout;
    
    fprintf(OutFile,"\n-------------------------------------");
    fprintf(OutFile,"--- Chaos Side ------\n");
    fprintf(OutFile,"\n me %i ",me);
    fprintf(OutFile,"\n numproc %i ",NumNodePgme(my_pgme));
    /* fprintf(OutFile,"\n Niter   ",IterationCounter); */
    fprintf(OutFile,"\n Timers ");


    min1=return_timer_min(1) ;
    my1=return_timer(1) ;
    max1=return_timer_max(1) ;
    avg1=return_timer_avg(1) ;

    min2=return_timer_min(2) ;
    my2=return_timer(2) ;
    max2=return_timer_max(2) ;
    avg2=return_timer_avg(2) ;

    fprintf(OutFile,"\n Compute Sched Chaos -> MB = %8i %8i %8i %8i",
            min1,my1,max1,avg1);
    fprintf(OutFile,"\n remap                  = %8i %8i %8i %8i",
	    min2,my2,max2,avg2);

    fprintf(OutFile,"\n-------------------------------------");

    if(me ==0)
      {
	fprintf(fp_max_scheds,"\n%d",max1);
	fprintf(fp_max_move,"\n%d",max2);
	
	fprintf(fp_avg_scheds,"\n%d",avg1);
	fprintf(fp_avg_move,"\n%d",avg2);
      }

    fclose(OutFile);

    if(me ==0){
      fclose(fp_max_scheds);
      fclose(fp_avg_scheds);
      fclose(fp_max_move);
      fclose(fp_avg_move);
    }


    }

    Sync2Pgme(my_pgme,other_pgme);
    if(me==0)pvm_exit();
    
    printf("\n Finished normally, me = %d(main2,Chaos) \n",me);

}



